ALTER TABLE LELTFEJ
DROP CONSTRAINT DF_LELTFEJ_CreTime;

ALTER TABLE LELTFEJ
ALTER COLUMN CreTime datetime;

ALTER TABLE LELTFEJ
ADD CONSTRAINT DF_LELTFEJ_CreTime DEFAULT GETDATE() FOR CreTime;

ALTER TABLE LELTSOR
DROP CONSTRAINT DF_LELTSOR_CreTime;

ALTER TABLE LELTSOR
ALTER COLUMN CreTime datetime;

ALTER TABLE LELTSOR
ADD CONSTRAINT DF_LELTSOR_CreTime DEFAULT GETDATE() FOR CreTime;

ALTER TABLE LELTSOR
ALTER COLUMN CreTime2 datetime;

ALTER TABLE RAKTARP
ALTER COLUMN Leltarozva datetime;

ALTER TABLE HISTORY
ALTER COLUMN Mikor datetime;

ALTER TABLE SZAMLAK
DROP CONSTRAINT DF_SZAMLAK_CreTime;

ALTER TABLE SZAMLAK
ALTER COLUMN CreTime datetime NOT NULL;

ALTER TABLE SZAMLAK
ADD CONSTRAINT DF_SZAMLAK_CreTime DEFAULT GETDATE() FOR CreTime;

UPDATE AKCIO SET Ervenyes = 'M' WHERE Ervenyes IS NULL;

ALTER TABLE ARAJVFEJ
DROP CONSTRAINT DF_ARAJVFEJ_CreTime;

ALTER TABLE ARAJVFEJ
ALTER COLUMN CreTime datetime NOT NULL;

ALTER TABLE ARAJVFEJ
ADD CONSTRAINT DF_ARAJVFEJ_CreTime DEFAULT GETDATE() FOR CreTime;

ALTER TABLE RENDVFEJ
DROP CONSTRAINT DF_RENDVFEJ_CreTime;

ALTER TABLE RENDVFEJ
ALTER COLUMN CreTime datetime NOT NULL;

ALTER TABLE RENDVFEJ
ADD CONSTRAINT DF_RENDVFEJ_CreTime DEFAULT GETDATE() FOR CreTime;

ALTER TABLE BIZFEJ
DROP CONSTRAINT DF_BIZFEJ_CreTime;

ALTER TABLE BIZFEJ
ALTER COLUMN CreTime datetime NOT NULL;

ALTER TABLE BIZFEJ
ADD CONSTRAINT DF_BIZFEJ_CreTime DEFAULT GETDATE() FOR CreTime;

WITH RENDVSOR_SORSZAM
AS
(
SELECT TetelSorsz, ROW_NUMBER() OVER (PARTITION BY RendvfejID ORDER BY RendvsorID) AS 'RowNumber'
FROM RENDVSOR
WHERE RENDVSOR.TetelSorsz IS NULL
)
UPDATE RENDVSOR_SORSZAM SET TetelSorsz = RowNumber;

WITH ARAJVSOR_SORSZAM
AS
(
SELECT TetelSorsz, ROW_NUMBER() OVER (PARTITION BY ArajVFejID ORDER BY ArajVSorid) AS 'RowNumber'
FROM ARAJVSOR
WHERE ARAJVSOR.TetelSorsz IS NULL
)
UPDATE ARAJVSOR_SORSZAM SET TetelSorsz = RowNumber;

UPDATE RAKTAR SET TelepID = 1 WHERE TelepID IS NULL;

ALTER TABLE BIZFEJ
ALTER COLUMN TeljKelt smalldatetime;

IF (SELECT COUNT(*) FROM UZL_KOTO WHERE UzlkotoCsp IS NULL) > 0 AND (SELECT COUNT(*) FROM HISTORYS WHERE HISTORYS.MltID = 7485) = 0
BEGIN
	INSERT INTO HISTORYS (HistID, MltID, RegiTartal)
	SELECT HISTORYS.histID, 7485, HISTORYS.RegiTartal
	FROM HISTORY
		 INNER JOIN HISTORYS ON HISTORYS.HistID = HISTORY.histID
	WHERE HISTORY.Esemeny = 'J' AND HISTORYS.MltID = 235
END;

UPDATE UZL_KOTO SET UzlkotoCsp = Uzlneve WHERE UzlkotoCsp IS NULL;

ALTER TABLE CIKKAKC
DROP CONSTRAINT DF_CIKKAKC_CreTime;

ALTER TABLE CIKKAKC
ALTER COLUMN CreTime datetime;

ALTER TABLE CIKKAKC
ADD CONSTRAINT DF_CIKKAKC_CreTime DEFAULT GETDATE() FOR CreTime;

ALTER TABLE WEBARAK
DROP CONSTRAINT DF_WEBARAK_CreTime;

ALTER TABLE WEBARAK
ALTER COLUMN CreTime datetime;

ALTER TABLE WEBARAK
ADD CONSTRAINT DF_WEBARAK_CreTime DEFAULT GETDATE() FOR CreTime;

DROP TRIGGER IF EXISTS tr_afak_modify2;
DROP TRIGGER IF EXISTS tr_akcio_modify4;
DROP TRIGGER IF EXISTS tr_akcio_modify5;
DROP TRIGGER IF EXISTS tr_arlista_modify2;
DROP TRIGGER IF EXISTS tr_cikkacsf_modify2;
DROP TRIGGER IF EXISTS tr_cikkacsh_modify2;
DROP TRIGGER IF EXISTS tr_cikkacsm_modify2;
DROP TRIGGER IF EXISTS tr_cikkacss_modify2;
DROP TRIGGER IF EXISTS tr_cikkacsx_modify2;
DROP TRIGGER IF EXISTS tr_cikkakc_modify4;
DROP TRIGGER IF EXISTS tr_cikkakc_modify5;
DROP TRIGGER IF EXISTS tr_cikkconh_modify2;
DROP TRIGGER IF EXISTS tr_cikkcons_modify2;
DROP TRIGGER IF EXISTS tr_cikkconx_modify2;
DROP TRIGGER IF EXISTS tr_cikkcsop_modify2;
DROP TRIGGER IF EXISTS tr_cikkhely_modify2;
DROP TRIGGER IF EXISTS tr_cikkhier_modify2;
DROP TRIGGER IF EXISTS tr_cikkkapc_modify2;
DROP TRIGGER IF EXISTS tr_cikkvedd_modify2;
DROP TRIGGER IF EXISTS tr_csomkuld_insert2;
DROP TRIGGER IF EXISTS tr_deviza_modify2;
DROP TRIGGER IF EXISTS tr_keszlet_modify2;
DROP TRIGGER IF EXISTS tr_koztertp_modify2;
DROP TRIGGER IF EXISTS tr_mee_modify2;
DROP TRIGGER IF EXISTS tr_raktar_modify2;
DROP TRIGGER IF EXISTS tr_szallito_modify2;
DROP TRIGGER IF EXISTS tr_szotar_modify2;
DROP TRIGGER IF EXISTS tr_utcak_modify2;
DROP TRIGGER IF EXISTS tr_varosok_modify2;
DROP TRIGGER IF EXISTS tr_vevoccsk_modify2;
DROP TRIGGER IF EXISTS tr_webarak_modify2;

UPDATE VONALKOD SET meID = (SELECT MeID FROM CIKK WHERE CIKK.CikkID = VONALKOD.CikkId) WHERE Szorzo = 1 AND meID IS NULL;