CREATE PROCEDURE [dbo].[sp_adozo_leker] @userID smallint, @stationID smallint, @adoszam varchar(8)
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SET @proxyAcc = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	--Ha van ToolsPath s bejelentkezsi adatok
	SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OnSzlaTnev IS NOT NULL AND OnSzlaPass IS NOT NULL AND OnSzlaKey IS NOT NULL AND OnSzlaCky IS NOT NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'OnlineSzamla\kri_nav.exe -operation:"queryTaxpayer" -test:0 -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'" -userID:'+CAST(@userID as varchar)+' -stationID:'+CAST(@stationID as varchar)+' -taxNumber:'+@adoszam

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command, 0, 1 --1-es paramter, hogy vrja meg a mveletet
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END

	;WITH XMLNAMESPACES('http://schemas.nav.gov.hu/OSA/3.0/api' as ns2, 'http://schemas.nav.gov.hu/OSA/3.0/base' as ns3, 'http://schemas.nav.gov.hu/NTCA/1.0/common' as ns4)
	SELECT
		ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerValidity)[1]', 'bit') AS 'Ervenyes',
		ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerName)[1]', 'varchar(512)') AS 'Nev',
		ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxNumberDetail/ns3:vatCode)[1]', 'varchar(1)') AS 'Afakod',
		ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxNumberDetail/ns3:countyCode)[1]', 'varchar(2)') AS 'Megyekod',
		ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:incorporation)[1]', 'varchar(15)') AS 'GazdasagiTipus',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:countryCode)[1]', 'varchar(2)') AS 'OrszagKod',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:postalCode)[1]', 'varchar(10)') AS 'Irsz',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:city)[1]', 'varchar(255)') AS 'Varos',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:streetName)[1]', 'varchar(255)') AS 'Utca',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:publicPlaceCategory)[1]', 'varchar(50)') AS 'Kozterulet',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:number)[1]', 'varchar(50)') AS 'Hsz',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:building)[1]', 'varchar(50)') AS 'Epulet',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:staircase)[1]', 'varchar(50)') AS 'Lepcsohaz',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:floor)[1]', 'varchar(50)') AS 'Emelet',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:door)[1]', 'varchar(50)') AS 'Ajto',
		ReceiveXML.value('((/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxpayerAddressList/ns2:taxpayerAddressItem/ns2:taxpayerAddressType[.="HQ"])[1]/../ns2:taxpayerAddress/ns3:lotNumber)[1]', 'varchar(50)') AS 'Hrsz',
		ReceiveXML.value('(/ns2:GeneralErrorResponse/ns4:result/ns4:message)[1]', 'varchar(1024)') AS 'Hiba'
	FROM TMPONLSZ
	WHERE CreUser = @userID AND StationID = @stationID AND ReceiveXML.value('(/ns2:QueryTaxpayerResponse/ns2:taxpayerData/ns2:taxNumberDetail/ns3:taxpayerId)[1]', 'varchar(8)') = @adoszam
END