CREATE PROCEDURE [dbo].[sp_bizsorp_insert] @bizsorID int = NULL, @forrasRaktarPID int = NULL, @celRaktarPID int = NULL, @cikkID int, @mennyi numeric(10,3) = NULL, @bMennyi numeric(10,3) = NULL, @userID smallint, @sorID int = NULL
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE 
	@keszletID int, @forrasRaktarID tinyint, @celRaktarID tinyint, @forrasKeszletPID int, @celKeszletPID int,
	@forrasKeszletPMennyi numeric(10,3), @forrasKeszletBMennyi numeric(10,3), @forrasPolcKod varchar(16), @segedInt int,
	@ujTranzakcio bit = 0

	IF @forrasRaktarPID IS NULL AND @celRaktarPID IS NULL
	BEGIN
		SELECT -1 AS hiba, 'A forrs raktr s a cl raktr nem lehet res' AS hibaszov
		RETURN
	END

	IF @sorID IS NOT NULL AND @celRaktarPID IS NULL
	BEGIN
		SELECT -1 AS hiba, 'Sor azonost esetn ktelez a cl raktr' AS hibaszov
		RETURN
	END

	IF @mennyi IS NULL AND @bMennyi IS NULL
	BEGIN
		SELECT -1 AS hiba, 'A kszlet mennyisg s a bevteli mennyisg nem lehet res' AS hibaszov
		RETURN
	END

	--Negatv forrsbl, kszlet nvels
	IF @mennyi IS NOT NULL AND @mennyi < 0 AND @forrasRaktarPID IS NOT NULL
	BEGIN
		SET @segedInt = @forrasRaktarPID
		SET @forrasRaktarPID = @celRaktarPID
		SET @celRaktarPID = @segedInt
	END

	BEGIN TRY
		IF @@TRANCOUNT = 0
		BEGIN
			SET @ujTranzakcio = 1
			BEGIN TRAN
		END

		IF @forrasRaktarPID IS NOT NULL
		BEGIN
			SELECT @forrasRaktarPID = RAKTARP.RaktarPID, @forrasRaktarID = RAKTAR.RaktarID, @keszletID = KESZLET.KeszletID, @forrasKeszletPID = KESZLETP.KeszletPID,
				   @forrasKeszletPMennyi = ISNULL(KESZLETP.Mennyi,0), @forrasKeszletBMennyi = ISNULL(KESZLETP.BevAlatt,0), @forrasPolcKod = RAKTARP.PolcKod
			FROM RAKTARP
				 LEFT JOIN RAKTAR ON RAKTAR.RaktarID = RAKTARP.RaktarID
				 LEFT JOIN KESZLET ON KESZLET.RaktarID = RAKTAR.RaktarID AND KESZLET.CikkID = @cikkID
				 LEFT JOIN KESZLETP ON KESZLETP.KeszletID = KESZLET.KeszletID AND KESZLETP.RaktarPID = RAKTARP.RaktarPID
			WHERE RAKTARP.RaktarPID = @forrasRaktarPID

			IF @forrasRaktarPID IS NULL
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'Nem azonosthat forrs raktr trhely' AS hibaszov
				RETURN
			END

			IF @keszletID IS NULL
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'Nincs forrs raktr kszlet' AS hibaszov
				RETURN
			END

			IF @forrasKeszletPMennyi IS NULL
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'A(z) ' + CONVERT(varchar, @cikkID) + ' cikkbl nincs kszletmennyisg a(z) ' + @forrasPolcKod + ' trhelyen' AS hibaszov
				RETURN
			END

			IF @forrasKeszletPMennyi < @mennyi
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'A(z) ' + CONVERT(varchar, @cikkID) + ' cikkbl csak ' + CONVERT(varchar, @forrasKeszletPMennyi) + ' kszletmennyisg van a(z) ' + @forrasPolcKod + ' trhelyen' AS hibaszov
				RETURN
			END

			IF @forrasKeszletBMennyi < @bMennyi
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'A(z) ' + CONVERT(varchar, @cikkID) + ' cikkbl csak ' + CONVERT(varchar, @forrasKeszletBMennyi) + ' bevtelezett mennyisg van a(z) ' + @forrasPolcKod + ' trhelyen' AS hibaszov
				RETURN
			END
		END

		IF @celRaktarPID IS NOT NULL
		BEGIN
			SELECT @celRaktarPID = RAKTARP.RaktarPID, @celRaktarID = RAKTAR.RaktarID, @keszletID = KESZLET.KeszletID, @celKeszletPID = KESZLETP.KeszletPID
			FROM RAKTARP
				 LEFT JOIN RAKTAR ON RAKTAR.RaktarID = RAKTARP.RaktarID
				 LEFT JOIN KESZLET ON KESZLET.RaktarID = RAKTAR.RaktarID AND KESZLET.CikkID = @cikkID
				 LEFT JOIN KESZLETP ON KESZLETP.KeszletID = KESZLET.KeszletID AND KESZLETP.RaktarPID = RAKTARP.RaktarPID
			WHERE RAKTARP.RaktarPID = @celRaktarPID

			IF @celRaktarPID IS NULL
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT -1 AS hiba, 'Nem azonosthat cl raktr trhely' AS hibaszov
				RETURN
			END

			IF @keszletID IS NULL
			BEGIN
				INSERT INTO KESZLET (CikkID, RaktarID) VALUES (@cikkID, @celRaktarID)
				SET @keszletID = SCOPE_IDENTITY()
			END

			IF @celKeszletPID IS NULL
			BEGIN
				INSERT INTO KESZLETP (KeszletID, RaktarPID, Mennyi) VALUES (@keszletID, @celRaktarPID, 0)
				SET @celKeszletPID = SCOPE_IDENTITY()
			END

			IF @sorID IS NOT NULL
				UPDATE RENDVSOR SET Raktid = @celRaktarID, KeszletPID = @celKeszletPID WHERE RendvsorID = @sorID
		END

		--Negatv forrsbl, kszlet nvels
		IF @segedInt IS NOT NULL
		BEGIN
			SET @segedInt = @forrasKeszletPID
			SET @forrasKeszletPID = @celKeszletPID
			SET @celKeszletPID = @segedInt
		END

		--Kszlet mozgats
		IF @mennyi IS NOT NULL AND @mennyi <> 0
			INSERT INTO BIZSORP (BizsorID, KeszletpID, KeszletcID, PMennyi, BMennyi, CreUser, RendvsorID) VALUES (@bizsorID, @forrasKeszletPID, @celKeszletPID, @mennyi, NULL, @userID, @sorID)

		--Bevtelezs alatti kszlet mozgats kln sorban
		IF @bMennyi IS NOT NULL AND @bMennyi <> 0
			INSERT INTO BIZSORP (BizsorID, KeszletpID, KeszletcID, PMennyi, BMennyi, CreUser, RendvsorID) VALUES (@bizsorID, @forrasKeszletPID, @celKeszletPID, NULL, @bMennyi, @userID, @sorID)

		IF @ujTranzakcio = 1
			COMMIT

		SELECT SCOPE_IDENTITY() AS hiba, '' AS hibaszov

	END TRY
	BEGIN CATCH
		IF @ujTranzakcio = 1
			ROLLBACK TRAN

		SELECT -1 AS hiba, Error_message() AS hibaszov
	END CATCH
END