CREATE PROCEDURE [dbo].[sp_cikk_akcio_sync]
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @webUserID smallint, @webUserID2 smallint, @gcmMuvInt int, @webKifutNap smallint, @cikkID int, @histID int

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225
	
	--WEB user azonost 2
	SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

	IF @webUserID = '' AND @webUserID2 = ''
		RETURN

	SET @gcmMuvInt = (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32)

	IF @webUserID <> ''
	BEGIN
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID)
		SELECT DISTINCT @gcmMuvInt, CIKK.CikkID, @webUserID
		FROM CIKKAKC
				INNER JOIN AKCIO ON AKCIO.AkcioID = CIKKAKC.AkcioID
				INNER JOIN CIKK ON CIKK.CikkID = CIKKAKC.CikkID
		WHERE (AKCIO.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS DATE) OR AKCIO.Tol = CAST(GETDATE() AS DATE)) AND AKCIO.TelepID IS NULL AND 
				ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Cikkhiercs IS NOT NULL AND CIKK.Webre = 1
	END

	IF @webUserID2 <> ''
	BEGIN
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID)
		SELECT DISTINCT @gcmMuvInt, CIKK.CikkID, @webUserID2
		FROM CIKKAKC
				INNER JOIN AKCIO ON AKCIO.AkcioID = CIKKAKC.AkcioID
				INNER JOIN CIKK ON CIKK.CikkID = CIKKAKC.CikkID
		WHERE (AKCIO.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS DATE) OR AKCIO.Tol = CAST(GETDATE() AS DATE)) AND AKCIO.TelepID IS NULL AND 
				ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Cikkhiercs IS NOT NULL AND CIKK.Webre2 = 1
	END

	IF @webUserID = ''
		RETURN

	--WEBrl kifut (nap)
	SELECT @webKifutNap = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 241

	IF @webKifutNap = '' OR @webKifutNap = 0
		RETURN

	IF CURSOR_STATUS('global','KifutCikkCursor')>=-1
	BEGIN
		CLOSE KifutCikkCursor
		DEALLOCATE KifutCikkCursor
	END

	DECLARE KifutCikkCursor CURSOR FOR

	SELECT CIKK.CikkID
	FROM KESZLET
		 INNER JOIN RAKTAR ON RAKTAR.RaktarID = KESZLET.RaktarID
		 INNER JOIN CIKK ON CIKK.CikkID = KESZLET.CikkID
	WHERE ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND 
		  ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Cikkhiercs IS NOT NULL AND CIKK.Webre = 1
	GROUP BY CIKK.CikkID
	HAVING SUM(KESZLET.Mennyi + ISNULL(KESZLET.BevAlatt, 0)) = 0 AND ISNULL(MAX(KESZLET.Ukivkelt),GETDATE()) < DATEADD(DAY, @webKifutNap * -1, GETDATE())
	ORDER BY CIKK.CikkID

	OPEN KifutCikkCursor

	BEGIN TRY
		BEGIN TRAN
	
		FETCH NEXT FROM KifutCikkCursor INTO @cikkID

		WHILE @@FETCH_STATUS = 0
		BEGIN
			UPDATE CIKK SET Webre = 0, WebreVissz = 1 WHERE CikkID = @cikkID

			INSERT INTO HISTORY (Mikor, UserID, Esemeny, Tablaid, Rekordid) VALUES (GETDATE(), @webUserID,'J',43,@cikkID)
			SET @histID=SCOPE_IDENTITY()

			--WEB-re mehet
			INSERT INTO HISTORYS (MltID, HistID, RegiTartal) VALUES (6886,@histID,1)

			--WEB-re visszatenni
			INSERT INTO HISTORYS (MltID, HistID, RegiTartal) VALUES (7389,@histID,0)

			FETCH NEXT FROM KifutCikkCursor INTO @cikkID
		END

		CLOSE KifutCikkCursor
		DEALLOCATE KifutCikkCursor

		COMMIT
	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END