CREATE PROCEDURE [dbo].[sp_esl_villog] @userID smallint, @stationID smallint, @barcode varchar(8000)
AS 
BEGIN
	SET NOCOUNT ON

	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50), @receiveVal varchar(8000)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SELECT @proxyAcc = LTRIM(RTRIM(ProxyAcc)), @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG ORDER BY CegID

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'DigitalisCimke\kri_dc.exe -operation:"flashLED" -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'" -barcode:"'+@barcode+'" -userID:'+CAST(@userID as varchar)+' -stationID:'+CAST(@stationID as varchar)

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command, 0, 1 --1-es paramter, hogy vrja meg a mveletet
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END

	SELECT @receiveVal = ReceiveVal FROM TMPPRICE WHERE CreUser = @userID AND StationID = @stationID

	IF @receiveVal IS NOT NULL
	BEGIN

		SELECT Split.a.value('.', 'NVARCHAR(MAX)') AS 'ReceiveVal'
		FROM
		(
			SELECT CAST('<RESULT>'+REPLACE(@receiveVal, '|', '</RESULT><RESULT>')+'</RESULT>' AS XML) AS String
		) AS A
		CROSS APPLY String.nodes('/RESULT') AS Split(a);

	END
	ELSE
		SELECT TOP 0 NULL AS 'ReceiveVal'

END