CREATE PROCEDURE [dbo].[sp_history_insert2] @userID int, @tltID smallint, @rekordID int, @esemeny char(1)

AS 
BEGIN 

BEGIN TRY

	DECLARE @histID int
	SET NOCOUNT ON

	--Kell szemle
	IF @esemeny = 'S'
	BEGIN
		IF (SELECT ISNULL(Nyomkovet, 0) FROM USERS WHERE UserID = @userID) = 0
        BEGIN
			SELECT 1 AS 'HistID'
			RETURN
        END
	END

	BEGIN TRAN
	INSERT INTO HISTORY (UserID, Mikor, Esemeny, Tablaid, Rekordid,
						 Sikertelen)
	             VALUES (@userID, GETDATE(),@esemeny, @tltID, @rekordID,
						 1)

	SET @histID = @@IDENTITY

	--Nem szemle, akkor sorok rgztse
	IF @esemeny <> 'S'
	BEGIN
		--#HISTORYS2 ltezik-e
		IF OBJECT_ID('tempdb..#HISTORYS2') IS NULL
		BEGIN
			ROLLBACK TRAN
			SELECT -1 AS 'HistID', 'Nem tallhat #HISTORYS2 tbla' AS 'HibaSzov'
			RETURN
		END
		
		INSERT INTO HISTORYS (MltID, HistID, RegiTartal)
		SELECT MltID, @histID, RegiTartal FROM #HISTORYS2
	END

	COMMIT TRAN
	SELECT @histID AS 'HistID', 'OK' AS 'HibaSzov'
END TRY
BEGIN CATCH
	ROLLBACK TRAN
	SELECT -1 AS 'HistID', ERROR_MESSAGE() AS 'HibaSzov'
END CATCH
END