CREATE PROCEDURE [dbo].[sp_kedeny_gcmsync] @kedenyID int, @kedenyekID smallint, @kukauritID smallint, @szolgID smallint, @RFCHIPID int, @szlaMod char(1), @korrekcio numeric(5,4), @tol date, @ig date, @statusz smallint, @szelektiv bit,
			@dKedenyID int, @dKedenyekID smallint, @dKukauritID smallint, @dSzolgID smallint, @dRFCHIPID int, @dSzlaMod char(1), @dKorrekcio numeric(5,4), @dTol date, @dIg date, @dStatusz smallint, @dSzelektiv bit,
			@vevoID int, @szghelyID int, @varosID smallint, @utcaID smallint, @koztertpID smallint, @webUserID smallint, @napi bit = 0
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @gcmMuvID int, @kedenyLetolt bit = 0, @kedenyTorol bit = 0, @kukaUritLetolt bit = 0, @kukaUritTorol bit = 0, @szolgIDLetolt bit = 0, @szolgIDTorol bit = 0, @RFCHIPIDLetolt bit = 0, @RFCHIPIDTorol bit = 0,
			@aktivVevoDb int, @aktivSzghelyDb int, @aktivVarosDb int, @aktivUtcaDb int, @aktivKozteruletDb int, @aktivKedenyekDb int, @aktivUritDb int, @aktivSzolgaltatasDb int, @aktivRFCHIPDb int

	--Aktv
	IF @statusz = 1 AND @tol <= CAST(GETDATE() AS date) AND (@ig IS NULL OR @ig >= CAST(GETDATE() AS date)) AND ISNULL(@szelektiv,0) = 0
	BEGIN
		--Ha aktv volt eltte is
		IF @dStatusz = 1 AND @dTol <= CAST(GETDATE() AS date) AND (@dIg IS NULL OR @dIg >= CAST(GETDATE() AS date)) AND ISNULL(@dSzelektiv,0) = 0 AND @dSzolgID IS NOT NULL 
		BEGIN
			--Mdostott kukaedny
			IF ISNULL(@kedenyekID, 0) <> ISNULL(@dKedenyekID, 0)
			BEGIN
				SET @kedenyLetolt = 1
				SET @kedenyTorol = 1
			END

			--Mdostott kuka rts
			IF ISNULL(@kukauritID, 0) <> ISNULL(@dKukauritID, 0)
			BEGIN
				IF @kukauritID IS NOT NULL
					SET @kukaUritLetolt = 1

				IF @dKukauritID IS NOT NULL
					SET @kukaUritTorol = 1
			END

			--Mdostott szolgltats
			IF ISNULL(@szolgID, 0) <> ISNULL(@dSzolgID, 0)
			BEGIN
				IF @szolgID IS NOT NULL
					SET @szolgIDLetolt = 1

				IF @dSzolgID IS NOT NULL
					SET @szolgIDTorol = 1
			END

			--Mdostott RFCHIP
			IF ISNULL(@RFCHIPID, 0) <> ISNULL(@dRFCHIPID, 0)
			BEGIN
				IF @RFCHIPID IS NOT NULL
					SET @RFCHIPIDLetolt = 1

				IF @dRFCHIPID IS NOT NULL
					SET @RFCHIPIDTorol = 1
			END
		END
		--Ha most aktivlja
		ELSE
		BEGIN
			--Vev aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivVevoDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.VevoID = @vevoID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivVevoDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.VevoID = @vevoID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivVevoDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vevoID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 88) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17), @vevoID, @webUserID) --Vev letlts
			END

			--Vros aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivVarosDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.SzgVarosID = @varosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivVarosDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.SzgVarosID = @varosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivVarosDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @varosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 71) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70), @varosID, @webUserID) --Vros letlts
			END

			--Ha van utca
			IF @utcaID IS NOT NULL
			BEGIN
				--Ha van kzterlet
				IF @koztertpID IS NOT NULL
				BEGIN
					--Kzterlet aktv-e mr
					IF @napi = 0
					BEGIN
						SET @aktivKozteruletDb =
						(SELECT COUNT(*)
						FROM KEDENY
					 		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					 		 INNER JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
						WHERE UTCAK.KoztertpID = @koztertpID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
					END
					--napi
					ELSE
					BEGIN
						SET @aktivKozteruletDb =
						(SELECT COUNT(*)
						FROM KEDENY
					 		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					 		 INNER JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
						WHERE UTCAK.KoztertpID = @koztertpID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
					END
					
					IF @aktivKozteruletDb = 0
					BEGIN
						UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @koztertpID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 75) --Zrtt tenni a korbbi trls esemnyt
						INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 74), @koztertpID, @webUserID) --Kzterlet letlts
					END
				END

				--Utca aktv-e mr
				IF @napi = 0
				BEGIN
					SET @aktivUtcaDb = (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @utcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
				END
				--napi
				ELSE
				BEGIN
					SET @aktivUtcaDb = (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @utcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
				END

				IF @aktivUtcaDb = 0
				BEGIN
					UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @utcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 73) --Zrtt tenni a korbbi trls esemnyt
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72), @utcaID, @webUserID) --Utca letlts
				END
			END

			--Szolgltatsi hely aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivSzghelyDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.SzghelyID = @szghelyID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivSzghelyDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE SZGHELY.SzghelyID = @szghelyID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivSzghelyDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szghelyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 89) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 16), @szghelyID, @webUserID) --Szolgltatsi hely letlts
			END

			SET @kedenyLetolt = 1

			IF @kukauritID IS NOT NULL
				SET @kukaUritLetolt = 1

			SET @szolgIDLetolt = 1

			IF @RFCHIPID IS NOT NULL
				SET @RFCHIPIDLetolt = 1
		END

		IF @kedenyLetolt = 1
		BEGIN
			--j kukaednyek aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivKedenyekDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.Kedenyekid = @kedenyekID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivKedenyekDb = 
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.Kedenyekid = @kedenyekID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivKedenyekDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @kedenyekID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 93) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 92), @kedenyekID, @webUserID) --Kukaednyek letlts
			END
		END

		IF @kukaUritLetolt = 1
		BEGIN
			--j kuka rts aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivUritDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.kukauritID = @kukauritID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivUritDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.kukauritID = @kukauritID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivUritDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @kukauritID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 95) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 94), @kukauritID, @webUserID) --Kuka rts letlts
			END
		END

		IF @szolgIDLetolt = 1
		BEGIN
			--j szolgltats aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivSzolgaltatasDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.SzolgID = @szolgID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivSzolgaltatasDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.SzolgID = @szolgID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivSzolgaltatasDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szolgID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 97) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 96), @szolgID, @webUserID) --Szolgltats letlts
			END
		END

		/* 20220204, csak RF-IT-tl rkezhet chip mdosts, nem kell visszajelezni
		(TODO: kltzsnl edenyhez chip is msolsra kerl, arrl nem kap rtestst, de nem hasznljk a kltzst)
		IF @RFCHIPIDLetolt = 1
		BEGIN
			--j kuka chip aktv-e mr
			IF @napi = 0
			BEGIN
				SET @aktivRFCHIPDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.RFCHIPID = @RFCHIPID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @kedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivRFCHIPDb =
				(SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.RFCHIPID = @RFCHIPID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol < @tol OR (KEDENY.Tol = @tol AND KEDENY.KEdenyID < @kedenyID)) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= @tol))
			END

			IF @aktivRFCHIPDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @RFCHIPID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 99) --Zrtt tenni a korbbi trls esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 98), @RFCHIPID, @webUserID) --Kuka chip letlts
			END
		END*/

		SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 90 --Kukaedny letlts

		--Letlts esetn zrtt tenni a korbbi trls esemnyt
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @kedenyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 91)
	END
	ELSE
	BEGIN
		--Vev aktv-e mg
		IF @napi = 0
		BEGIN
			SET @aktivVevoDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.VevoID = @vevoID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivVevoDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.VevoID = @vevoID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivVevoDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vevoID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 88), @vevoID, @webUserID) --Vev trls
		END

		--Szolgltatsi hely aktv-e mg
		IF @napi = 0
		BEGIN
			SET @aktivSzghelyDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.SzghelyID = @szghelyID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivSzghelyDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.SzghelyID = @szghelyID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivSzghelyDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szghelyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 16) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 89), @szghelyID, @webUserID) --Szolgltatsi hely trls
		END

		--Vros aktv-e mg
		IF @napi = 0
		BEGIN
			SET @aktivVarosDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.SzgVarosID = @varosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivVarosDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE SZGHELY.SzgVarosID = @varosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivVarosDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @varosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 71), @varosID, @webUserID) --Vros trls
		END

		--Ha van utca
		IF @utcaID IS NOT NULL
		BEGIN
			--Utca aktv-e mg
			IF @napi = 0
			BEGIN
				SET @aktivUtcaDb = (SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @utcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
			END
			--napi
			ELSE
			BEGIN
				SET @aktivUtcaDb = (SELECT COUNT(*)
				FROM KEDENY
					 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @utcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
			END

			IF @aktivUtcaDb = 0
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @utcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72) --Zrtt tenni a korbbi letlts esemnyeket
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 73), @utcaID, @webUserID) --Utca trls
			END

			--Ha van kzterlet
			IF @koztertpID IS NOT NULL
			BEGIN
				--Kzterlet aktv-e mg
				IF @napi = 0
				BEGIN
					SET @aktivKozteruletDb =
					(SELECT COUNT(*)
					FROM KEDENY
					 	 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 	 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					 	 INNER JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
					WHERE UTCAK.KoztertpID = @koztertpID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
				END
				--napi
				ELSE
				BEGIN
					SET @aktivKozteruletDb =
					(SELECT COUNT(*)
					FROM KEDENY
					 	 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
					 	 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					 	 INNER JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
					WHERE UTCAK.KoztertpID = @koztertpID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
				END
					
				IF @aktivKozteruletDb = 0
				BEGIN
					UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @koztertpID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 74) --Zrtt tenni a korbbi letlts esemnyeket
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 75), @koztertpID, @webUserID) --Kzterlet trls
				END
			END
		END

		SET @kedenyTorol = 1

		IF @dKukauritID IS NOT NULL
			SET @kukaUritTorol = 1

		SET @szolgIDTorol = 1

		IF @dRFCHIPID IS NOT NULL
			SET @RFCHIPIDTorol = 1

		SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 91 --Kukaedny trls

		--Trls esetn zrtt tenni a korbbi letlts esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dKedenyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 90)
	END

	IF @kedenyTorol = 1
	BEGIN
		--Kukaednyek aktv-e mg
		IF @napi = 0
		BEGIN
			SET @aktivKedenyekDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.Kedenyekid = @dKedenyekID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivKedenyekDb = 
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.Kedenyekid = @dKedenyekID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivKedenyekDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dKedenyekID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 92) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 93), @dKedenyekID, @webUserID) --Kukaednyek trls
		END
	END

	IF @kukaUritTorol = 1
	BEGIN
		--Rgi kuka rts nincs mr sehol
		IF @napi = 0
		BEGIN
			SET @aktivUritDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.kukauritID = @dKukauritID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivUritDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.kukauritID = @dKukauritID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivUritDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dKukauritID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 94) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 95), @dKukauritID, @webUserID) --Kuka rts trls
		END
	END

	IF @szolgIDTorol = 1
	BEGIN
		--Rgi szolgltats nincs mr sehol
		IF @napi = 0
		BEGIN
			SET @aktivSzolgaltatasDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.SzolgID = @dSzolgID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivSzolgaltatasDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.SzolgID = @dSzolgID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivSzolgaltatasDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dSzolgID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 96) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 97), @dSzolgID, @webUserID) --Szolgltats trls
		END
	END

	/* 20220204, csak RF-IT-tl rkezhet chip mdosts, nem kell visszajelezni
	(TODO: kltzsnl edenyhez chip is msolsra kerl, arrl nem kap rtestst, de nem hasznljk a kltzst)
	IF @RFCHIPIDTorol = 1
	BEGIN
		--Rgi kuka chip nincs mr sehol
		IF @napi = 0
		BEGIN
			SET @aktivRFCHIPDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.RFCHIPID = @dRFCHIPID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.KEdenyID <> @dKedenyID AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)))
		END
		--napi
		ELSE
		BEGIN
			SET @aktivRFCHIPDb =
			(SELECT COUNT(*)
			FROM KEDENY
				 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
			WHERE KEDENY.RFCHIPID = @dRFCHIPID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date) OR (KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date) AND KEDENY.KEdenyID > @dKedenyID)))
		END

		IF @aktivRFCHIPDb = 0
		BEGIN
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dRFCHIPID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 98) --Zrtt tenni a korbbi letlts esemnyeket
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 99), @dRFCHIPID, @webUserID) --Kuka chip trls
		END
	END*/

	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, ISNULL(@kedenyID,@dKedenyID), @webUserID)
END