CREATE PROCEDURE [dbo].[sp_szamlatetel_leker] @szamlaszam varchar(50), @userID smallint, @stationID smallint, @kimeno bit = 0
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50), @verzio varchar(3), @szamla XML

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SET @proxyAcc = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	--Ha van ToolsPath s bejelentkezsi adatok
	SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OnSzlaTnev IS NOT NULL AND OnSzlaPass IS NOT NULL AND OnSzlaKey IS NOT NULL AND OnSzlaCky IS NOT NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'OnlineSzamla\kri_nav.exe -operation:"queryInvoiceData" -test:0 -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'" -invoiceNumber:"'+@szamlaszam+'" -userID:'+CAST(@userID as varchar)+' -stationID:'+CAST(@stationID as varchar)+(CASE WHEN @kimeno=1 THEN ' -outbound:1' ELSE '' END)

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command, 0, 1 --1-es paramter, hogy vrja meg a mveletet
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END

	;WITH XMLNAMESPACES('http://schemas.nav.gov.hu/OSA/3.0/common' as ns, 'http://schemas.nav.gov.hu/OSA/3.0/api' as ns2)
	SELECT @verzio = ReceiveXML.value('(ns2:QueryInvoiceDataResponse/ns2:invoiceDataResult/ns2:auditData/ns2:originalRequestVersion)[1]', 'varchar(3)'),
		   @szamla = CONVERT(XML, ReceiveXML.value('(ns2:QueryInvoiceDataResponse/ns2:invoiceDataResult/ns2:invoiceData)[1]', 'varbinary(max)'))
	FROM TMPONLSZ
	WHERE CreUser = @userID AND StationID = @stationID

	IF @verzio = '2.0'
	BEGIN
		;WITH XMLNAMESPACES('http://schemas.nav.gov.hu/OSA/2.0/data' as ns)
		SELECT
			Col.value('(ns:lineNumber)[1]', 'int') AS 'Sorszam',
			Col.value('(ns:lineDescription)[1]', 'varchar(512)') AS 'Megnevezes',
			Col.value('(ns:quantity)[1]', 'numeric(22,6)') AS 'Mennyiseg',
			Col.value('(ns:unitOfMeasure)[1]', 'varchar(20)') AS 'MENAV',
			Col.value('(ns:unitOfMeasureOwn)[1]', 'varchar(50)') AS 'MESajat',
			Col.value('(ns:unitPrice)[1]', 'numeric(22,6)') AS 'Egysegar',
			Col.value('(ns:unitPriceHUF)[1]', 'numeric(22,6)') AS 'EgysegarFt',
			Col.value('(ns:lineDiscountData/ns:discountDescription)[1]', 'varchar(255)') AS 'KedvezmenyLeiras',
			Col.value('(ns:lineDiscountData/ns:discountValue)[1]', 'numeric(18,2)') AS 'KedvezmenyErtek',
			Col.value('(ns:lineDiscountData/ns:discountRate)[1]', 'numeric(5,4)') AS 'KedvezmenySzazalek',

			--Norml szmla
			Col.value('(ns:lineAmountsNormal/ns:lineNetAmountData/ns:lineNetAmount)[1]', 'numeric(18,2)') AS 'Netto',
			Col.value('(ns:lineAmountsNormal/ns:lineNetAmountData/ns:lineNetAmountHUF)[1]', 'numeric(18,2)') AS 'NettoFt',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatPercentage)[1]', 'numeric(5,4)') AS 'AFASzazalek',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatExemption)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'AFAMentesKod',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatOutOfScope)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'AFAHatalyKod',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatDomesticReverseCharge)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'ForditottAFA',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:marginSchemeVat)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'AtharitottAFA',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:marginSchemeNoVat)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'NemAtharitottAFA',
			Col.value('(ns:lineAmountsNormal/ns:lineVatData/ns:lineVatAmount)[1]', 'numeric(18,2)') AS 'AFA',
			Col.value('(ns:lineAmountsNormal/ns:lineVatData/ns:lineVatAmountHUF)[1]', 'numeric(18,2)') AS 'AFAFt',
			Col.value('(ns:lineAmountsNormal/ns:lineGrossAmountData/ns:lineGrossAmountNormal)[1]', 'numeric(18,2)') AS 'Brutto',
			Col.value('(ns:lineAmountsNormal/ns:lineGrossAmountData/ns:lineGrossAmountNormalHUF)[1]', 'numeric(18,2)') AS 'BruttoFt',
	
			--Egyszerstett szmla
			Col.value('(ns:lineAmountsSimplified/ns:lineVatRate/ns:vatPercentage)[1]', 'numeric(5,4)') AS 'AFASzazalekEgyszeru',
			Col.value('(ns:lineAmountsSimplified/ns:lineGrossAmountSimplified)[1]', 'numeric(18,2)') AS 'BruttoEgyszeru',
			Col.value('(ns:lineAmountsSimplified/ns:lineGrossAmountSimplifiedHUF)[1]', 'numeric(18,2)') AS 'BruttoFtEgyszeru',

			CASE WHEN LOWER(Col.value('(ns:intermediatedService)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'KozvetitettSzolg'

		FROM @szamla.nodes('ns:InvoiceData/ns:invoiceMain/ns:invoice/ns:invoiceLines/ns:line') AS Tab(Col)
	END
	ELSE
	BEGIN
		;WITH XMLNAMESPACES('http://schemas.nav.gov.hu/OSA/3.0/data' as ns)
		SELECT
			Col.value('(ns:lineNumber)[1]', 'int') AS 'Sorszam',
			Col.value('(ns:lineDescription)[1]', 'varchar(512)') AS 'Megnevezes',
			Col.value('(ns:quantity)[1]', 'numeric(22,6)') AS 'Mennyiseg',
			Col.value('(ns:unitOfMeasure)[1]', 'varchar(20)') AS 'MENAV',
			Col.value('(ns:unitOfMeasureOwn)[1]', 'varchar(50)') AS 'MESajat',
			Col.value('(ns:unitPrice)[1]', 'numeric(22,6)') AS 'Egysegar',
			Col.value('(ns:unitPriceHUF)[1]', 'numeric(22,6)') AS 'EgysegarFt',
			Col.value('(ns:lineDiscountData/ns:discountDescription)[1]', 'varchar(255)') AS 'KedvezmenyLeiras',
			Col.value('(ns:lineDiscountData/ns:discountValue)[1]', 'numeric(18,2)') AS 'KedvezmenyErtek',
			Col.value('(ns:lineDiscountData/ns:discountRate)[1]', 'numeric(5,4)') AS 'KedvezmenySzazalek',

			--Norml szmla
			Col.value('(ns:lineAmountsNormal/ns:lineNetAmountData/ns:lineNetAmount)[1]', 'numeric(18,2)') AS 'Netto',
			Col.value('(ns:lineAmountsNormal/ns:lineNetAmountData/ns:lineNetAmountHUF)[1]', 'numeric(18,2)') AS 'NettoFt',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatPercentage)[1]', 'numeric(5,4)') AS 'AFASzazalek',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatExemption/ns:case)[1]', 'varchar(50)') AS 'AFAMentesKod',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatExemption/ns:reason)[1]', 'varchar(100)') AS 'AFAMentesLeiras',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatOutOfScope/ns:case)[1]', 'varchar(50)') AS 'AFAHatalyKod',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatOutOfScope/ns:reason)[1]', 'varchar(100)') AS 'AFAHatalyLeiras',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatDomesticReverseCharge)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'ForditottAFA',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:marginSchemeVat)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'AtharitottAFA',
			CASE WHEN LOWER(Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:marginSchemeNoVat)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'NemAtharitottAFA',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatAmountMismatch/ns:case)[1]', 'varchar(50)') AS 'AFAElteresKod',
			Col.value('(ns:lineAmountsNormal/ns:lineVatRate/ns:vatAmountMismatch/ns:reason)[1]', 'varchar(100)') AS 'AFAElteresLeiras',
			Col.value('(ns:lineAmountsNormal/ns:lineVatData/ns:lineVatAmount)[1]', 'numeric(18,2)') AS 'AFA',
			Col.value('(ns:lineAmountsNormal/ns:lineVatData/ns:lineVatAmountHUF)[1]', 'numeric(18,2)') AS 'AFAFt',
			Col.value('(ns:lineAmountsNormal/ns:lineGrossAmountData/ns:lineGrossAmountNormal)[1]', 'numeric(18,2)') AS 'Brutto',
			Col.value('(ns:lineAmountsNormal/ns:lineGrossAmountData/ns:lineGrossAmountNormalHUF)[1]', 'numeric(18,2)') AS 'BruttoFt',
	
			--Egyszerstett szmla
			Col.value('(ns:lineAmountsSimplified/ns:lineVatRate/ns:vatContent)[1]', 'numeric(5,4)') AS 'AFASzazalekEgyszeru',
			Col.value('(ns:lineAmountsSimplified/ns:lineGrossAmountSimplified)[1]', 'numeric(18,2)') AS 'BruttoEgyszeru',
			Col.value('(ns:lineAmountsSimplified/ns:lineGrossAmountSimplifiedHUF)[1]', 'numeric(18,2)') AS 'BruttoFtEgyszeru',

			CASE WHEN LOWER(Col.value('(ns:intermediatedService)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'KozvetitettSzolg'

		FROM @szamla.nodes('ns:InvoiceData/ns:invoiceMain/ns:invoice/ns:invoiceLines/ns:line') AS Tab(Col)
	END
END