CREATE TRIGGER [dbo].[tr_bizfej_update] ON [dbo].[BIZFEJ]
FOR UPDATE
AS

--BIZFEJ
DECLARE @bizfejID int, @devizaID tinyint, @kedvezmeny numeric(5,2), @dKedvezmeny numeric(5,2), @nettoFt money, 
@afaFt money, @nettoDeviza money, @afaDeviza money, @kelt smalldatetime, @dKelt smalldatetime,

--MOZGNEM
@szallev bit, @irany char(1), @partner char(1),

--DEVIZA
@szlaRound tinyint

SELECT @bizfejID=inserted.BizfejID, @devizaID=inserted.DevizaID, @kedvezmeny=inserted.Kedvezmeny, 
	   @szallev=ISNULL(MOZGNEM.SzallLev,0), @szlaRound=DEVIZA.SzlaRound, @kelt=Kelt, @irany=Irany, @partner=MOZGNEM.Partner
FROM inserted
	 LEFT JOIN MOZGNEM ON inserted.mozgnemID=MOZGNEM.MozgnemID
     LEFT JOIN DEVIZA ON DEVIZA.DevizaID=inserted.DevizaID

SELECT @dKedvezmeny=Kedvezmeny, @dKelt=Kelt FROM deleted

--Utols bevtelezs dtuma
IF @partner = 'S' AND @kelt <> @dKelt
BEGIN

	--BIZSOR
	DECLARE @cikkID int, @raktarID int, @mennyi decimal(10,3),

	--CIKK
	@beszDatum smalldatetime

	DECLARE BizsorCursor CURSOR FOR

		SELECT CikkID, RaktarID, Mennyi FROM BIZSOR WHERE BizfejID=@bizfejID

	OPEN BizsorCursor

	FETCH NEXT FROM BizsorCursor INTO @cikkID, @raktarID, @mennyi

	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF (@irany='N' AND @mennyi > 0) OR (@irany='C' AND @mennyi < 0)
		BEGIN
			SELECT @beszDatum = MAX(BIZFEJ.Kelt)
			FROM BIZSOR
				 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
				 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
			WHERE BIZSOR.CikkID = @cikkID AND MOZGNEM.Partner = 'S' AND
			((MOZGNEM.Irany = 'N' AND BIZSOR.Mennyi > 0) OR (MOZGNEM.Irany = 'C' AND BIZSOR.Mennyi < 0))

			UPDATE CIKK SET BeszDatum=@beszDatum WHERE CikkID=@cikkID
		END

		FETCH NEXT FROM BizsorCursor INTO @cikkID, @raktarID, @mennyi
	END

	CLOSE BizsorCursor
	DEALLOCATE BizsorCursor

END

--Ha nem szlltlevl vagy nem vltozott a kedvezmny
IF @szallev = 0 OR ISNULL(@kedvezmeny,0) = ISNULL(@dKedvezmeny,0)
	RETURN

--Bizonylat fej ttelszm, nett, brutt, szlltlevl nett, szlltlevl brutt, devizartk jraszmols
SELECT @nettoFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi), 
       @afaFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100)), 
       @nettoDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi), 
       @afaDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100))
FROM BIZSOR 
     LEFT JOIN AFAK ON BIZSOR.AfaID=AFAK.AfaID
WHERE BIZSOR.BizfejID=@bizfejID

SET @kedvezmeny=ISNULL(@kedvezmeny,0)

--Elads Ft-os rtk
SET @nettoFt=ROUND(@nettoFt * (100-@kedvezmeny)/100, 0)
SET @afaFt=ROUND(@afaFt * (100-@kedvezmeny)/100, 0)

--Elads devizs rtk
IF @devizaID IS NOT NULL AND @devizaID <> 1
BEGIN
	SET @nettoDeviza=ROUND(@nettoDeviza * (100-@kedvezmeny)/100, @szlaRound)
	SET @afaDeviza=ROUND(@afaDeviza * (100-@kedvezmeny)/100, @szlaRound)
END
ELSE
BEGIN
	SET @nettoDeviza=NULL
	SET @afaDeviza=NULL
END

UPDATE BIZFEJ SET NettoS=@nettoFt, BruttoS=@nettoFt+@afaFt, DevizaErt=@nettoDeviza+@afaDeviza WHERE BizfejID=@bizfejID