CREATE TRIGGER [dbo].[tr_bizsor_delete] ON [dbo].[BIZSOR]
FOR delete
AS

DECLARE @keszletSql nvarchar(1000) = '',

--BIZSOR
@bizsorID int, @bizfejID int, @cikkID int, @raktarID int, @mennyi decimal(10,3),
@elsz_ert money, @raktarTip char(1), @celRaktarTip char(1), @cikkSarzID int,

--BIZFEJ
@bizKelt date, @tetelfejID int, @devizaID tinyint, @kedvezmeny numeric(5,2), @munkalapID int,
@netto money, @afa money, @nettoFt money, @afaFt money, @nettoDeviza money,
@afaDeviza money, @db as int,@vanzaro int,

--MOZGNEM
@konyvEv tinyint, @irany char(1), @szSzam varchar(8), @specKod char(1), @partner char(1), @bizjel varchar(4),

--DEVIZA
@szlaRound tinyint,

--KESZLET
@keszletID int, @halmBevet decimal(11,3), @halmKiadas decimal(11,3), @keszletMennyi decimal(11,3), @raktErtek money, @uKivKelt date,

--KESZLETS
@keszletSID int

SELECT @bizsorID=deleted.BizsorID, @bizfejID=deleted.BizfejID, @cikkID=deleted.CikkID, @raktarID=deleted.RaktarID, @mennyi=deleted.Mennyi, 
	   @elsz_ert=deleted.Ertek, @raktarTip=RAKTAR.RaktarTip, @celRaktarTip=ISNULL(CELRAKTAR.RaktarTip,' '), @bizKelt=BIZFEJ.Kelt, @tetelfejID=BIZFEJ.tetelfejID,
	   @devizaID=BIZFEJ.DevizaID, @kedvezmeny=BIZFEJ.Kedvezmeny, @munkalapID=BIZFEJ.MunkalapID, @konyvEv=MOZGNEM.KonyvEv, @irany=MOZGNEM.Irany,
	   @szSzam=MOZGNEM.SzSzam, @specKod=MOZGNEM.SpecKod, @partner=MOZGNEM.Partner, @bizjel=MOZGNEM.Bizjel, @szlaRound=DEVIZA.SzlaRound, @cikkSarzID=deleted.CikkSarzID
FROM deleted
     LEFT JOIN RAKTAR ON deleted.RaktarID=RAKTAR.RaktarID
     LEFT JOIN RAKTAR CELRAKTAR ON CELRAKTAR.RaktarID=deleted.CelRaktar
	 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=deleted.BizfejID
	 LEFT JOIN MOZGNEM ON BIZFEJ.mozgnemID=MOZGNEM.MozgnemID
     LEFT JOIN DEVIZA ON DEVIZA.DevizaID=BIZFEJ.DevizaID

--Kszlet kezels
IF ISNULL(@cikkID, 0) > 0
BEGIN
	SELECT @keszletID=keszletID, @keszletMennyi=Mennyi FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

	--kiads FIFO
	IF @irany='C' AND dbo.fc_setup('R',@konyvEv,60)='FIFO' 
	BEGIN
		EXEC dbo.sp_fifo 2, @cikkID, @raktarID, @bizKelt, @mennyi, @bizsorID
	END

	--Van-e ves zrs
	SELECT TOP 1 @vanZaro=BIZFEJ.BizfejID
	FROM BIZFEJ
		 INNER JOIN  MOZGNEM ON BIZFEJ.mozgnemID=MOZGNEM.MozgnemID
 	WHERE MOZGNEM.Bizjel='ZARO' AND BIZFEJ.Tetelszam > 0

	--Kszlet jraszmols
	SELECT @halmBevet=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'N' THEN BIZSOR.Mennyi ELSE 0 END),0),
		   @halmKiadas=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'C' THEN BIZSOR.Mennyi ELSE 0 END),0),
		   @raktErtek=ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'N' THEN 1 ELSE -1 END) * BIZSOR.Ertek),0)
	FROM BIZSOR
		 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
		 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
	WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID  and (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0)
	
	SET @keszletMennyi=@halmBevet-@halmKiadas

	SET @keszletSql = @keszletSql + 'Mennyi=' + CONVERT(varchar, @keszletMennyi) + ', HalmBevet=' + CONVERT(varchar, @halmBevet) + ', HalmKiadas=' + CONVERT(varchar, @halmKiadas)

	--0 kszlet
	IF @keszletMennyi=0
	BEGIN
		--bizonylatsorok kerektsei miatti eltrs
		/*IF @raktErtek <> 0
		BEGIN
			DECLARE @bizsorErtek money
			DECLARE @bizsorMennyi dec (8,2) --mdostshoz
			SELECT @bizsorErtek=Ertek, @bizsorMennyi=Mennyi FROM BIZSOR WHERE BizsorID=@bizsorID		
			SET @bizsorErtek=@bizsorErtek + @raktErtek
			SET @egysegAr=@bizsorErtek / @bizsorMennyi

			UPDATE BIZSOR SET Ertek=@bizsorErtek, EgysegAr=@egysegAr WHERE BizsorID=@bizsorID
		END*/
		
		SET @keszletSql = @keszletSql + ', RaktErtek=0' 
	END
	--Nem 0 kszlet
	ELSE
	BEGIN
		SET @keszletSql = @keszletSql + ', RaktErtek=' + CONVERT(varchar, @raktErtek)

		--tlagr tszmols csak pozitv kszlet esetn
		IF @keszletMennyi > 0
			SET @keszletSql = @keszletSql + ', AtlagAr=ISNULL(' + CONVERT(varchar, @raktErtek) + ',0) / ' + CONVERT(varchar, @keszletMennyi)
	END

	--Utols kivt kezels, ha nem zr bizonylat
	IF ((@irany='C' AND @mennyi > 0) OR (@irany='N' AND @mennyi < 0)) AND @bizjel <> 'ZARO'
	BEGIN
		SELECT @uKivKelt = MAX(BIZFEJ.Kelt)
		FROM BIZSOR
			 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
			 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
		WHERE BIZSOR.CikkID = @cikkID AND BIZSOR.RaktarID = @raktarID AND MOZGNEM.Bizjel <> 'ZARO' AND
		((MOZGNEM.Irany = 'C' AND BIZSOR.Mennyi > 0) OR (MOZGNEM.Irany = 'N' AND BIZSOR.Mennyi < 0)) AND BIZSOR.BizsorID <> @bizsorID

		SET @keszletSql = @keszletSql + ', Ukivkelt=''' + CONVERT(varchar, @uKivKelt, 23) + ''''
	END
	--Utols bevtelezs dtuma
	ELSE IF @partner = 'S' AND ((@irany='N' AND @mennyi > 0) OR (@irany='C' AND @mennyi < 0))
	BEGIN
		SELECT @uKivKelt = MAX(BIZFEJ.Kelt)
		FROM BIZSOR
				INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
				INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
		WHERE BIZSOR.CikkID = @cikkID AND MOZGNEM.Partner = 'S' AND
		((MOZGNEM.Irany = 'N' AND BIZSOR.Mennyi > 0) OR (MOZGNEM.Irany = 'C' AND BIZSOR.Mennyi < 0))

		UPDATE CIKK SET BeszDatum=@uKivKelt WHERE CikkID=@cikkID
	END

	--LOT kezels
	IF @cikkSarzID IS NOT NULL
	BEGIN
		SELECT @keszletSID=KeszletSID FROM KESZLETS WHERE KeszletID=@keszletID AND CikkSarzID=@cikkSarzID

		--Nincs mg ilyen kszlet
		IF @@ROWCOUNT=0 
		BEGIN
			INSERT INTO KESZLETS (KeszletID, CikkSarzID, SMennyi) VALUES (@keszletID, @cikkSarzID, @mennyi)
			SET @keszletSID=SCOPE_IDENTITY()
		END
		ELSE
		BEGIN
			--Kszlet jraszmols
			SELECT @halmBevet=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'N' THEN BIZSOR.Mennyi ELSE 0 END),0),
				   @halmKiadas=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'C' THEN BIZSOR.Mennyi ELSE 0 END),0)
			FROM BIZSOR
				 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
				 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
			WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID and (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0) AND BIZSOR.CikkSarzID=@cikkSarzID

			UPDATE KESZLETS SET SMennyi=@halmBevet-@halmKiadas WHERE KeszletSID=@keszletSID
		END
	END
END

IF @keszletSql <> ''
BEGIN
	SET @keszletSql = 'UPDATE KESZLET SET ' + @keszletSql + ' WHERE KeszletID=' + CONVERT(varchar, @keszletID)
	exec sp_executesql @keszletSql
END

--Bizonylat fej ttelszm, nett, brutt, szlltlevl nett, szlltlevl brutt, devizartk jraszmols
SELECT @netto=SUM(BIZSOR.Ertek), 
       @afa=SUM(BIZSOR.Ertek * (AFAK.Szaz/100)),
       @nettoFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi), 
       @afaFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100)), 
       @nettoDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi), 
       @afaDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100)),
       @db=COUNT(BIZSOR.BizsorID) 
FROM BIZSOR 
     LEFT JOIN AFAK ON BIZSOR.AfaID=AFAK.AfaID
WHERE BIZSOR.BizfejID=@bizfejID

SET @kedvezmeny=ISNULL(@kedvezmeny,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @db=ISNULL(@db,0)

SET @netto=ROUND(@netto, 0)
SET @afa=ROUND(@afa, 0)

--Elads Ft-os rtk
SET @nettoFt=ROUND(@nettoFt * (100-@kedvezmeny)/100, 0)
SET @afaFt=ROUND(@afaFt * (100-@kedvezmeny)/100, 0)

--Elads devizs rtk
IF @devizaID IS NOT NULL AND @devizaID <> 1
BEGIN
	SET @nettoDeviza=ROUND(@nettoDeviza * (100-@kedvezmeny)/100, @szlaRound)
	SET @afaDeviza=ROUND(@afaDeviza * (100-@kedvezmeny)/100, @szlaRound)
END
ELSE
BEGIN
	SET @nettoDeviza=NULL
	SET @afaDeviza=NULL
END

UPDATE BIZFEJ SET Tetelszam=@db, Netto=@netto, Brutto=@netto+@afa, NettoS=@nettoFt, BruttoS=@nettoFt+@afaFt, DevizaErt=@nettoDeviza+@afaDeviza WHERE BizfejID=@bizfejID

--szllt rendels sor hivatkozs trls
UPDATE RENDSSOR SET BizsorID=NULL WHERE BizsorID=@bizsorID

IF ISNULL(@cikkID, 0) = 0
	RETURN

/*--TODO, csak ha ez az utols ttel
--Raktrkzi tadsnl nem kell beszerzsi rat berni
IF @partner='S' AND @irany='N' AND @egysegAr<>0 AND RTRIM(dbo.fc_setup('R',@konyvEv,185))='Igen' --185 - Utols beszerzsi r trhat
 UPDATE CIKK SET BeszAr=@egysegAr WHERE CikkID=@cikkID

--TODO, csak ha ez az utols ttel
--Szllt utols ra
IF @irany='N' AND @egysegAr<>0 AND @szallitoID>0
  UPDATE CIKKCEGS SET LastAr=@egysegAr, LastIn=@bizKelt WHERE CikkID=@cikkID AND SzallitoID=@szallitoID AND (LastIn<=@bizKelt OR LastIn IS NULL)
*/

--Munkalap anyagkltsg
IF @munkalapID IS NOT NULL
begin
	UPDATE MUNKLAP SET KtgAnyag=(
		SELECT ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'C' THEN 1 ELSE -1 END) * BIZSOR.Ertek),0)  AS 'Ertek'
		FROM BIZSOR
			 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
			 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
		WHERE BIZFEJ.MunkalapID=@munkalapID AND BIZSOR.CikkID IS NOT NULL)
	WHERE MunkalapID=@munkalapID

	UPDATE RENDvSOR SET BizSorID=NULL WHERE BizSorID=@bizsorID
end
--res mozgsnem szmlaszm vagy raktrkzi kiadsnl vagy (a clraktr nem bizomnyosi s raktrkzi bevt) vagy bizomnyos raktrt nem kell knyvelni
IF LTRIM(ISNULL(@szSzam,''))='' OR @specKod='A' OR (@celRaktarTip <> 'B' AND @specKod='B') OR @raktarTip='B'
	RETURN

DECLARE @tetelsorID int, @tartozik money, @sztukorID int

SELECT @sztukorID=Sztukorid
FROM SZTUKOR
	 LEFT JOIN CIKKCSOP ON SZTUKOR.Szsz=CIKKCSOP.KeszSzam
	 LEFT JOIN CIKK ON CIKK.CikkCsopID=CIKKCSOP.Cikkcsopid  
WHERE SZTUKOR.KonyvEv=@konyvEv AND CIKK.CikkID=@cikkID

if @irany='N'
    select @tetelsorID=tetelsorID,@tartozik=tartozik from tetelsor 
    where tetelfejID=@tetelfejID and szszID=@sztukorid
else
    select @tetelsorID=tetelsorID,@tartozik=tartozik from tetelsor 
    where tetelfejID=@tetelfejID and eszszID=@sztukorid

if isnull(@tetelsorID,-1)>0
begin
if @tartozik<>@elsz_ert
    begin
        update tetelsor set tartozik=tartozik-@elsz_ert,osszeg=osszeg-@elsz_ert 
            where @tetelsorID=tetelsorID
        update ktg_fel set osszeg=osszeg-@elsz_ert where @tetelsorID=tetelsorID  
    end
 else
    begin
        delete from ktg_fel where tetelsorID=@tetelsorID
        delete from tetelsor where tetelsorID=@tetelsorID
        update tetelfej set tetelszam=tetelszam-1 where tetelfejID=@tetelfejID
    end
end