CREATE TRIGGER [dbo].[tr_bizsorm_insert] ON [dbo].[BIZSORM]
FOR INSERT, UPDATE, DELETE
AS
DECLARE @cikkID int, @raktarID tinyint, @mennyi numeric(10,3), @bizsorID int,
		@keszletID int, @bevAlatt numeric(11,3)

DECLARE BizsormCursor CURSOR FOR

	SELECT CikkID, RaktarID, Mennyi, BizsorID FROM inserted
	UNION
	SELECT CikkID, RaktarID, Mennyi, BizsorID FROM deleted

OPEN BizsormCursor

FETCH NEXT FROM BizsormCursor INTO @cikkID, @raktarID, @mennyi, @bizsorID

WHILE @@FETCH_STATUS = 0
BEGIN
	SELECT @bevAlatt=SUM(Mennyi) FROM BIZSORM WHERE CikkID=@cikkID AND RaktarID=@raktarID AND BizsorID IS NULL
	SELECT @keszletID=KeszletID FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

    IF @keszletID IS NULL
        INSERT INTO KESZLET (CikkID,RaktarID,BevAlatt) VALUES (@cikkID,@raktarID,@bevAlatt)
    ELSE
        UPDATE KESZLET SET BevAlatt=@bevAlatt WHERE KeszletID=@keszletID

	FETCH NEXT FROM BizsormCursor INTO @cikkID, @raktarID, @mennyi, @bizsorID
END

CLOSE BizsormCursor
DEALLOCATE BizsormCursor