CREATE TRIGGER [dbo].[tr_bizsorp_insert2] ON [dbo].[BIZSORP]
FOR INSERT, UPDATE, DELETE
AS

DECLARE @forrasKeszletPID int, @celKeszletPID int, @keszletID int, @rendvsorID int, @forrasGyujto bit, @celGyujto bit, @keszletFrissit bit = 0, @webUserID2 smallint

--Flex-Fnynl a gyjt polcra pakolst is kszlet vltozsnak kell venni
IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') = 0
	RETURN

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF ISNULL(@webUserID2,'') = ''
	RETURN

DECLARE BizsorpCursor CURSOR FOR

--DISTINCT mdosts miatt ne legyen 2 sor
SELECT L2.KeszletpID, L2.KeszletcID, L2.RendvsorID, L2.KeszletID,
	(CASE WHEN ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Webre2 = 1 AND Cikkhiercs IS NOT NULL THEN (CASE WHEN L2.ForrasRaktarPID = RAKTAR.GyujtoPID OR L2.ForrasRaktarPID = RAKTAR.RendPID OR L2.ForrasRaktarPID = RAKTAR.BoltiPID OR L2.ForrasRaktarPID = RAKTAR.WEBPID OR L2.ForrasRaktarPID = RAKTAR.EladPID THEN 1 ELSE 0 END) ELSE 0 END) AS 'ForrasGyujto',
	(CASE WHEN ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Webre2 = 1 AND Cikkhiercs IS NOT NULL THEN (CASE WHEN L2.CelRaktarPID = RAKTAR.GyujtoPID OR L2.CelRaktarPID = RAKTAR.RendPID OR L2.CelRaktarPID = RAKTAR.BoltiPID OR L2.CelRaktarPID = RAKTAR.WEBPID OR L2.CelRaktarPID = RAKTAR.EladPID THEN 1 ELSE 0 END) ELSE 0 END) AS 'CelGyujto'
FROM (
	SELECT DISTINCT L.KeszletpID, L.KeszletcID, L.RendvsorID, ISNULL(KESZLETP.KeszletID, CEL_KESZLETP.KeszletID) AS 'KeszletID', KESZLETP.RaktarPID AS 'ForrasRaktarPID', CEL_KESZLETP.RaktarPID AS 'CelRaktarPID' 
	FROM (
		SELECT KeszletpID, KeszletcID, RendvsorID FROM inserted
		UNION
		SELECT KeszletpID, KeszletcID, RendvsorID FROM deleted) L
	LEFT JOIN KESZLETP ON KESZLETP.KeszletPID = L.KeszletpID
	LEFT JOIN KESZLETP CEL_KESZLETP ON CEL_KESZLETP.KeszletPID = L.KeszletcID) L2
LEFT JOIN KESZLET ON KESZLET.KeszletID = L2.KeszletID
LEFT JOIN RAKTAR ON RAKTAR.RaktarID = KESZLET.RaktarID
LEFT JOIN CIKK ON CIKK.CikkID = KESZLET.CikkID

OPEN BizsorpCursor

FETCH NEXT FROM BizsorpCursor INTO @forrasKeszletPID, @celKeszletPID, @rendvsorID, @keszletID, @forrasGyujto, @celGyujto

WHILE @@FETCH_STATUS = 0
BEGIN
	IF @forrasKeszletPID IS NOT NULL
	BEGIN
		--Ha forrs trhely gyjt s nem gyjtrl gyjtre helyezte s nem eladta (van cl trhely)
		IF @forrasGyujto = 1 AND @celGyujto = 0 AND @celKeszletPID IS NOT NULL
			SET @keszletFrissit = 1
	END

	IF @celKeszletPID IS NOT NULL
	BEGIN
		--Ha mg nincs kszletfrissts s a cl trhely gyjt s nem gyjtrl gyjtre helyezte s nem rendelsbl leraks, akkor kszlet vltozs
		IF @keszletFrissit = 0 AND @celGyujto = 1 AND @forrasGyujto = 0 AND @rendvsorID IS NULL
			SET @keszletFrissit = 1
	END

	IF @keszletFrissit = 1
	BEGIN
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62),@keszletID,@webUserID2) --Kszlet letlts
	END

	FETCH NEXT FROM BizsorpCursor INTO @forrasKeszletPID, @celKeszletPID, @rendvsorID, @keszletID, @forrasGyujto, @celGyujto
END

CLOSE BizsorpCursor
DEALLOCATE BizsorpCursor