CREATE TRIGGER [dbo].[tr_cikk_update] ON [dbo].[CIKK] FOR INSERT,UPDATE,DELETE
AS

--Automatikus ablak frissts
IF (SELECT UPPER(LTRIM(RTRIM(ISNULL(Ertek, '')))) FROM SETUP WHERE SetupID = 208) <> 'IGEN'
	RETURN

DECLARE @serviceName varchar(max), @cikkID int, @keszletID int, @update bit = 0,
		@message varchar(6000) = N'<changes><change tableName = ''CIKK'' type=''',
		@keszletMessage varchar(6000) = ''

IF (SELECT COUNT(*) FROM inserted) > 0
BEGIN
	IF (SELECT COUNT(*) FROM deleted) = 0
		SET @message += 'insert'
	ELSE
	BEGIN
		SET @message += 'update'
		SET @update = 1
	END
END
ELSE IF (SELECT COUNT(*) FROM deleted) > 0
	SET @message += 'delete'
ELSE
	RETURN

SET @message += '''>'

IF CURSOR_STATUS('global','RefreshCikkCursor')>=-1
BEGIN
	CLOSE RefreshCikkCursor
	DEALLOCATE RefreshCikkCursor
END

DECLARE RefreshCikkCursor CURSOR FOR

	SELECT CikkID FROM inserted
	UNION
	SELECT CikkID FROM deleted

OPEN RefreshCikkCursor

FETCH NEXT FROM RefreshCikkCursor INTO @cikkID

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @message += '<id>' + CAST(@cikkID AS varchar) + '</id>'

	--Kszlet frissts
	IF @update = 1
	BEGIN
		DECLARE KeszletCursor CURSOR FOR

		SELECT KeszletID
		FROM KESZLET
		WHERE CikkID = @cikkID

		OPEN KeszletCursor

		FETCH NEXT FROM KeszletCursor INTO @keszletID

		WHILE @@FETCH_STATUS = 0
		BEGIN
			SET @keszletMessage += '<id>' + CAST(@keszletID AS varchar) + '</id>'
			FETCH NEXT FROM KeszletCursor INTO @keszletID
		END

		CLOSE KeszletCursor
		DEALLOCATE KeszletCursor
	END

	FETCH NEXT FROM RefreshCikkCursor INTO @cikkID
END

CLOSE RefreshCikkCursor
DEALLOCATE RefreshCikkCursor

IF @keszletMessage <> ''
BEGIN
	SET @keszletMessage = N'<change tableName = ''KESZLET'' type=''update''>' + @keszletMessage + '</change>'
END

BEGIN TRANSACTION

DECLARE ServiceCursor CURSOR FOR

	SELECT name FROM sys.services WHERE name LIKE 'KristalyRowRefreshService%'

OPEN ServiceCursor

FETCH NEXT FROM ServiceCursor INTO @serviceName

WHILE @@FETCH_STATUS = 0
BEGIN

	DECLARE @NotificationDialog UNIQUEIDENTIFIER
	BEGIN DIALOG CONVERSATION @NotificationDialog
	FROM SERVICE @serviceName
	TO SERVICE @serviceName
	ON CONTRACT [http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification]
	WITH ENCRYPTION = OFF;
	SEND ON CONVERSATION @NotificationDialog 
	MESSAGE TYPE [http://schemas.microsoft.com/SQL/Notifications/QueryNotification] (@message + '</change>' + @keszletMessage + '</changes>')
	END CONVERSATION @NotificationDialog WITH CLEANUP
	FETCH NEXT FROM ServiceCursor INTO @serviceName
END

CLOSE ServiceCursor
DEALLOCATE ServiceCursor

COMMIT TRANSACTION