CREATE TRIGGER [dbo].[tr_fogyhell_update] ON [dbo].[FOGYHELL]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @fogyHEllID int, 
	@lezarva smalldatetime, @szamlazni bit, @kiadMod char(1),
	@dLezarva smalldatetime, @dSzamlazni bit, @dKiadMod char(1),

	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @fogyHEllID = FogyHEllID, @lezarva = Lezarva, @szamlazni = Szamlazni, @kiadMod = KiadMod FROM inserted
	SELECT @dLezarva = Lezarva, @dSzamlazni = Szamlazni, @dKiadMod = KiadMod FROM deleted

	BEGIN TRY

		BEGIN TRAN

		--lezrs
		IF @lezarva IS NOT NULL AND @dLezarva IS NULL
			BEGIN
			--GCM Sync tblbl trls
			DELETE FROM GCMSYNCU WHERE GCMSyncID IN (SELECT GCMSyncID FROM GCMSYNC WHERE FogyHEllID = @fogyHEllID)
			DELETE FROM GCMSYNC WHERE FogyHEllID = @fogyHEllID
		END
		ELSE
		BEGIN
			--Ha mr zrt vagy nem vltozott az tadott rtkek valamelyike
			IF @lezarva IS NOT NULL OR ((ISNULL(@szamlazni, 0) = ISNULL(@dSzamlazni, 0)) AND ISNULL(@kiadMod,'') = ISNULL(@dKiadMod,''))
			BEGIN
				COMMIT
				RETURN
			END

			SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 6 -- Ellenrzs mdosts

			SELECT @userID = USERS.UserID
			FROM FOGYHELL
				 LEFT JOIN SZHELLEN ON SZHELLEN.SZHELLENID =  FOGYHELL.EllSzem
				 LEFT JOIN USERS ON USERS.SzemelyID = SZHELLEN.szemelyID
			WHERE FOGYHELL.FogyHEllID = @fogyhellID AND FOGYHELL.Lezarva IS NULL AND USERS.SyncInterv IS NOT NULL

			--Ha nincs felhasznlhoz ktve
			IF @userID IS NULL
			BEGIN
				COMMIT
				RETURN
			END

			SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID) VALUES (@gcmMuvID, @fogyHEllID, @userID, @fogyHEllID)
		END

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END