CREATE TRIGGER [dbo].[tr_fohely_update] ON [dbo].[FOHELY]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @fohelyID int, 
	@gyszam varchar(15), @meret tinyint, @tipus tinyint, @merostru char(1), @beepitve date, @hitelesEv smallint, @vipak varchar(30), @vipakDate date, @latti numeric(10,6), @longi numeric(10,6), @leolvSajMj varchar(100), @induloOra int,
	@dGyszam varchar(15), @dMeret tinyint, @dTipus tinyint, @dMerostru char(1), @dBeepitve date, @dHitelesEv smallint, @dVipak varchar(30), @dVipakDate date, @dLatti numeric(10,6), @dLongi numeric(10,6), @dLeolvSajMj varchar(100), @dInduloOra int,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @csomagID int, @fogyHEllID int, @ocsereerID int

	SELECT @fohelyID = FohelyID, @gyszam = Gyszam, @meret = Meret, @tipus = Tipus, @merostru = Merostru, @beepitve = Beepitve, @hitelesEv = HitelesEv, @vipak = Vipak, @vipakDate = VipakDate, @latti = Latti, @longi = Longi, @leolvSajMj = LeolvSajMj, @induloOra = InduloOra FROM inserted
	SELECT @fohelyID = FohelyID, @dGyszam = Gyszam, @dMeret = Meret, @dTipus = Tipus, @dMerostru = Merostru, @dBeepitve = Beepitve, @dHitelesEv = HitelesEv, @dVipak = Vipak, @dVipakDate = VipakDate, @dLatti = Latti, @dLongi = Longi, @dLeolvSajMj = LeolvSajMj, @dInduloOra = InduloOra FROM deleted

	--ha nem vltozott a leolvasshoz tadott rtkek valamelyike
	IF ISNULL(@gyszam, '') = ISNULL(@dGyszam, '') AND ISNULL(@meret, 0) = ISNULL(@dMeret, 0) AND ISNULL(@tipus, 0) = ISNULL(@dTipus, 0) AND ISNULL(@merostru, '') = ISNULL(@dMerostru, '') AND ISNULL(@beepitve, '1900.01.01') = ISNULL(@dBeepitve, '1900.01.01') AND ISNULL(@hitelesEv, 0) = ISNULL(@dHitelesEv, 0) AND ISNULL(@vipak, '') = ISNULL(@dVipak, '') AND ISNULL(@vipakDate, '1900.01.01') = ISNULL(@dVipakDate, '1900.01.01') AND ISNULL(@latti, 0) = ISNULL(@dLatti, 0) AND ISNULL(@longi, 0) = ISNULL(@dLongi, 0) AND ISNULL(@leolvSajMj, '') = ISNULL(@dLeolvSajMj, '') AND ISNULL(@induloOra, 0) = ISNULL(@dInduloOra, 0)
		RETURN

	IF CURSOR_STATUS('global','FohelyCursor')>=-1
	BEGIN
		CLOSE FohelyCursor
		DEALLOCATE FohelyCursor
	END

	DECLARE FohelyCursor CURSOR FOR

	SELECT L.UserID, MAX(L.CsomagID) AS 'CsomagID', MAX(L.FogyHEllID) AS 'FogyHEllID', MAX(L.OcsereerID) AS 'OcsereerID' FROM (
	SELECT ISNULL(leolvast.UserIDt, LEOLVASO.UserID) AS 'UserID', MAX(OLVASCSM.CsomagID) AS 'CsomagID', NULL AS 'FogyHEllID', NULL AS 'OcsereerID'
	FROM FOHELY
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = FOHELY.SzghelyID
		 JOIN OLVASCSM ON
					(CASE WHEN OLVASCSM.LeolvasoID IS NULL AND OLVASCSM.Leolvas2ID IS NULL THEN 0 ELSE ISNULL(SZGHELY.Leolvaso, 0) END IN (ISNULL(OLVASCSM.LeolvasoID, 0), ISNULL(OLVASCSM.Leolvas2ID, 0))) AND
					(CASE WHEN OLVASCSM.SzgcsopID IS NULL AND OLVASCSM.SzgCsopID2 IS NULL THEN 0 ELSE SZGHELY.SzgCsopID END IN (ISNULL(OLVASCSM.SzgcsopID, 0), ISNULL(OLVASCSM.SzgCsopID2, 0))) AND
					(CASE WHEN OLVASCSM.SzlaciklID IS NULL AND OLVASCSM.Szlacikli2 IS NULL THEN 0 ELSE SZGHELY.SzlaCiklID END IN (ISNULL(OLVASCSM.SzlaciklID, 0), ISNULL(OLVASCSM.Szlacikli2, 0))) AND
					(CASE WHEN OLVASCSM.Varosid IS NULL AND OLVASCSM.VarosID2 IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgVarosID, 0) END IN (ISNULL(OLVASCSM.Varosid, 0), ISNULL(OLVASCSM.VarosID2, 0))) AND
					(CASE WHEN OLVASCSM.utcaid IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgUtcaID, 0) END = ISNULL(OLVASCSM.utcaid, 0))
		INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = OLVASCSM.LeolvasoID
		INNER JOIN USERS ON USERS.UserID = LEOLVASO.Userid
		LEFT JOIN leolvast ON leolvast.leolvastID = OLVASCSM.Munkavegzo
	WHERE FOHELY.FohelyID = @fohelyID AND FOHELY.Ig IS NULL AND FOHELY.Mero <> 1 AND LEOLVASO.PsionTip = 'A' AND OLVASCSM.Psionba IS NOT NULL AND OLVASCSM.Psionbol IS NULL AND OLVASCSM.Kartonra IS NULL
	GROUP BY ISNULL(leolvast.UserIDt, LEOLVASO.UserID)

	UNION

	SELECT USERS.UserID, NULL AS 'CsomagID', MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
	FROM NAPTAR
		 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
		 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
		 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
		 LEFT JOIN OCSEREES ON OCSEREES.OcsereerID = OCSEREER.OcsereerID
		 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
		 LEFT JOIN SZGHELY ON SZGHELY.SzghelyID = FOGYHELL.SzghelyID
		 LEFT JOIN FOHELY ON FOHELY.SzghelyID = SZGHELY.SzghelyID
	WHERE (OCSEREES.FohelyID = @fohelyID OR FOHELY.FohelyID = @fohelyID) AND USERS.SyncInterv IS NOT NULL 
	GROUP BY USERS.UserID) L
	GROUP BY L.UserID

	OPEN FohelyCursor

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 4 --Fogyaszthely mdosts

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM FohelyCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @fohelyID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

			FETCH NEXT FROM FohelyCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		END

		CLOSE FohelyCursor
		DEALLOCATE FohelyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END