CREATE TRIGGER [dbo].[tr_kedenyek_modify] ON [dbo].[KEDENYEK]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @kedenyekID smallint, @kedenyekNv varchar(40),
			@dKedenyekID smallint, @dKedenyekNv varchar(40),
			@webUserID smallint

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN

	IF CURSOR_STATUS('global','KedenyekCursor')>=-1
	BEGIN
		CLOSE KedenyekCursor
		DEALLOCATE KedenyekCursor
	END

	DECLARE KedenyekCursor CURSOR FOR

	SELECT inserted.KedenyekID, deleted.KedenyekID, inserted.KedenyekNv, deleted.KedenyekNv
	FROM deleted
		 LEFT JOIN inserted ON inserted.KedenyekID = deleted.KedenyekID
	     INNER JOIN KEDENY ON KEDENY.KedenyekID = deleted.KedenyekID
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(deleted.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.KedenyekID, deleted.KedenyekID, inserted.KedenyekNv, deleted.KedenyekNv

	OPEN KedenyekCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM KedenyekCursor INTO @kedenyekID, @dKedenyekID, @kedenyekNv, @dKedenyekNv
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@kedenyekNv, '') <> ISNULL(@dKedenyekNv, '')
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = ISNULL(@kedenyekID,@dKedenyekID) AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @kedenyekID IS NULL THEN 92 ELSE 93 END)) --Zrtt tenni a korbbi esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @kedenyekID IS NULL THEN 93 ELSE 92 END)), ISNULL(@kedenyekID,@dKedenyekID), @webUserID)
			END

			FETCH NEXT FROM KedenyekCursor INTO @kedenyekID, @dKedenyekID, @kedenyekNv, @dKedenyekNv
		END

		CLOSE KedenyekCursor
		DEALLOCATE KedenyekCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END