CREATE TRIGGER [dbo].[tr_keszlet_update] ON [dbo].[KESZLET] FOR INSERT,UPDATE
AS

--Automatikus ablak frissts
IF (SELECT UPPER(LTRIM(RTRIM(ISNULL(Ertek, '')))) FROM SETUP WHERE SetupID = 208) <> 'IGEN'
	RETURN

DECLARE @serviceName varchar(max), @keszletID int, @tovabbiKeszletID int, @cikkID int, @message varchar(6000) = N'<changes><change tableName = ''KESZLET'' type='''

IF (SELECT COUNT(*) FROM inserted) > 0
BEGIN
	IF (SELECT COUNT(*) FROM deleted) = 0
		SET @message += 'insert'
	ELSE
		SET @message += 'update'
END
ELSE IF (SELECT COUNT(*) FROM deleted) = 0
	RETURN

SET @message += '''>'

DECLARE KeszletCursor CURSOR FOR

	SELECT KeszletID, CikkID FROM inserted

OPEN KeszletCursor

FETCH NEXT FROM KeszletCursor INTO @keszletID, @cikkID

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @message += '<id>' + CAST(@keszletID AS varchar) + '</id>'

	DECLARE TovabbiKeszletCursor CURSOR FOR

	SELECT KeszletID
	FROM KESZLET
	WHERE KeszletID <> @keszletID AND CikkID = @cikkID

	OPEN TovabbiKeszletCursor

	FETCH NEXT FROM TovabbiKeszletCursor INTO @tovabbiKeszletID

	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @message += '<tovabbiKeszletID>' + CAST(@tovabbiKeszletID AS varchar) + '</tovabbiKeszletID>'

		FETCH NEXT FROM TovabbiKeszletCursor INTO @tovabbiKeszletID
	END

	CLOSE TovabbiKeszletCursor
	DEALLOCATE TovabbiKeszletCursor

	FETCH NEXT FROM KeszletCursor INTO @keszletID, @cikkID
END

CLOSE KeszletCursor
DEALLOCATE KeszletCursor

BEGIN TRANSACTION

DECLARE ServiceCursor CURSOR FOR

	SELECT name FROM sys.services WHERE name LIKE 'KristalyRowRefreshService%'

OPEN ServiceCursor

FETCH NEXT FROM ServiceCursor INTO @serviceName

WHILE @@FETCH_STATUS = 0
BEGIN

	DECLARE @NotificationDialog UNIQUEIDENTIFIER
	BEGIN DIALOG CONVERSATION @NotificationDialog
	FROM SERVICE @serviceName
	TO SERVICE @serviceName
	ON CONTRACT [http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification]
	WITH ENCRYPTION = OFF;
	SEND ON CONVERSATION @NotificationDialog 
	MESSAGE TYPE [http://schemas.microsoft.com/SQL/Notifications/QueryNotification] (@message + '</change></changes>')
	END CONVERSATION @NotificationDialog WITH CLEANUP
	FETCH NEXT FROM ServiceCursor INTO @serviceName
END

CLOSE ServiceCursor
DEALLOCATE ServiceCursor

COMMIT TRANSACTION