CREATE TRIGGER [dbo].[tr_koztertp_modify_kuka] ON [dbo].[KOZTERTP]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @koztertpID smallint, @koztertpNv varchar(15),
			@dKoztertpID smallint, @dKoztertpNv varchar(15),
			@webUserID smallint, @gcmMuvID int

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN
	
	IF CURSOR_STATUS('global','UtcaCursor')>=-1
	BEGIN
		CLOSE UtcaCursor
		DEALLOCATE UtcaCursor
	END

	DECLARE UtcaCursor CURSOR FOR

	SELECT inserted.KoztertpID, deleted.KoztertpID, inserted.KoztertpNv, deleted.KoztertpNv
	FROM deleted
		 LEFT JOIN inserted ON inserted.KoztertpID = deleted.KoztertpID
		 INNER JOIN UTCAK ON UTCAK.KoztertpID = deleted.KoztertpID
		 INNER JOIN SZGHELY ON ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = UTCAK.UtcaID
	     INNER JOIN KEDENY ON KEDENY.SzghelyID = SZGHELY.SzghelyID
	     INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.KoztertpID, deleted.KoztertpID, inserted.KoztertpNv, deleted.KoztertpNv

	OPEN UtcaCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM UtcaCursor INTO @koztertpID, @dKoztertpID, @koztertpNv, @dKoztertpNv
		WHILE @@FETCH_STATUS = 0
		BEGIN

			IF @gcmMuvID IS NULL
				SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @koztertpID IS NULL THEN 75 ELSE 74 END) --75: Kzterlet trls, 74: Kzterlet mdosts

			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@koztertpNv, '') <> ISNULL(@dKoztertpNv, '')
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, ISNULL(@koztertpID,@dKoztertpID), @webUserID)

			FETCH NEXT FROM UtcaCursor INTO @koztertpID, @dKoztertpID, @koztertpNv, @dKoztertpNv
		END

		CLOSE UtcaCursor
		DEALLOCATE UtcaCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END