CREATE TRIGGER [dbo].[tr_ocsereer_update] ON [dbo].[OCSEREER]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @ocsereerID int, 
	@lezarva smalldatetime, @kiadasMod char(1), @szamlaz char(1), @kedvezmeny bit,
	@dLezarva smalldatetime, @dKiadasMod char(1), @dSzamlaz char(1), @dKedvezmeny bit,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @ocsereerID = OcsereerID, @lezarva = Lezarva, @kiadasMod = KIadasMod, @szamlaz = Szamlaz, @kedvezmeny = Kedvezmeny FROM inserted
	SELECT @dLezarva = Lezarva, @dKiadasMod = KIadasMod, @dSzamlaz = Szamlaz, @dKedvezmeny = Kedvezmeny FROM deleted

	BEGIN TRY

		BEGIN TRAN

		--lezrs
		IF @lezarva IS NOT NULL AND @dLezarva IS NULL
		BEGIN
			--GCM Sync tblbl trls
			DELETE FROM GCMSYNCU WHERE GCMSyncID IN (SELECT GCMSyncID FROM GCMSYNC WHERE OcsereerID = @ocsereerID)
			DELETE FROM GCMSYNC WHERE OcsereerID = @ocsereerID
		END
		ELSE
		BEGIN
			--Ha mr zrt vagy nem vltozott az tadott rtkek valamelyike
			IF @lezarva IS NOT NULL OR (@kiadasMod = @dKiadasMod AND ISNULL(@szamlaz, '') = ISNULL(@dSzamlaz, '') AND ISNULL(@kedvezmeny, 0) = ISNULL(@dKedvezmeny, 0))
			BEGIN
				COMMIT
				RETURN
			END

			SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 9 -- racsere mdosts

			SELECT @userID = USERS.UserID
			FROM OCSEREER
				 INNER JOIN SZCSERE ON SZCSERE.SzCsereID = OCSEREER.SzCsereID
				 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = SZCSERE.Szemelyid
				 INNER JOIN USERS ON USERS.SzemelyID = SZEMELY.SzemelyID
			WHERE OCSEREER.OcsereerID = @ocsereerID AND OCSEREER.Lezarva IS NULL AND USERS.SyncInterv IS NOT NULL

			--Ha nincs felhasznlhoz ktve
			IF @userID IS NULL
			BEGIN
				COMMIT
				RETURN
			END

			SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID) VALUES (@gcmMuvID, @ocsereerID, @userID, @ocsereerID)
		END

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END