CREATE TRIGGER [dbo].[tr_olvas_insert] ON [dbo].[OLVAS]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE
	@olvasID int, @fohelyID int, @szamlaID int,
	@dOlvasID int, @dSzamlaID int,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int, @csomagID int, @fogyHEllID int, @ocsereerID int

	SELECT @olvasID = OlvasID, @fohelyID = FohelyID, @szamlaID = SzamlaID FROM inserted
	SELECT @dOlvasID = OlvasID, @fohelyID = FohelyID, @dSzamlaID = SzamlaID FROM deleted

	BEGIN TRY

		BEGIN TRAN

		IF @olvasID IS NOT NULL
		BEGIN
			IF @dOlvasID IS NULL
				SET @gcmMuvInt = 1 -- j ralls
			ELSE
			BEGIN
				SET @gcmMuvInt = 2 -- ralls mdosts

				--Szmlzs
				IF @szamlaID IS NOT NULL AND @dSzamlaID IS NULL
				BEGIN
					--Nem kszl szmla
					IF @szamlaID = -1
					BEGIN
						COMMIT
						RETURN
					END

					--Tmegszmla
					IF (SELECT COUNT(*)	FROM SZAMLAK INNER JOIN RGZNAPLO ON RGZNAPLO.RgzID = SZAMLAK.RgzID WHERE SZAMLAK.SzamlaID = @szamlaID AND RGZNAPLO.Neve NOT LIKE '%.hkzi') = 1
					BEGIN
						COMMIT
						RETURN
					END
				END
			END
		END
		ELSE
		BEGIN
			SET @gcmMuvInt = 3 --ralls trls
			SET @olvasID = @dOlvasID

			-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @olvasID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (1,2))
		END

		IF CURSOR_STATUS('global','OlvacsmCursor')>=-1
		BEGIN
			CLOSE OlvacsmCursor
			DEALLOCATE OlvacsmCursor
		END

		DECLARE OlvacsmCursor CURSOR FOR

		SELECT L.UserID, MAX(L.CsomagID) AS 'CsomagID', MAX(L.FogyHEllID) AS 'FogyHEllID', MAX(L.OcsereerID) AS 'OcsereerID' FROM (
		SELECT ISNULL(leolvast.UserIDt, LEOLVASO.UserID) AS 'UserID', MAX(OLVASCSM.CsomagID) AS 'CsomagID', NULL AS 'FogyHEllID', NULL AS 'OcsereerID'
		FROM FOHELY
			 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = FOHELY.SzghelyID
			 JOIN OLVASCSM ON
						(CASE WHEN OLVASCSM.LeolvasoID IS NULL AND OLVASCSM.Leolvas2ID IS NULL THEN 0 ELSE ISNULL(SZGHELY.Leolvaso, 0) END IN (ISNULL(OLVASCSM.LeolvasoID, 0), ISNULL(OLVASCSM.Leolvas2ID, 0))) AND
						(CASE WHEN OLVASCSM.SzgcsopID IS NULL AND OLVASCSM.SzgCsopID2 IS NULL THEN 0 ELSE SZGHELY.SzgCsopID END IN (ISNULL(OLVASCSM.SzgcsopID, 0), ISNULL(OLVASCSM.SzgCsopID2, 0))) AND
						(CASE WHEN OLVASCSM.SzlaciklID IS NULL AND OLVASCSM.Szlacikli2 IS NULL THEN 0 ELSE SZGHELY.SzlaCiklID END IN (ISNULL(OLVASCSM.SzlaciklID, 0), ISNULL(OLVASCSM.Szlacikli2, 0))) AND
						(CASE WHEN OLVASCSM.Varosid IS NULL AND OLVASCSM.VarosID2 IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgVarosID, 0) END IN (ISNULL(OLVASCSM.Varosid, 0), ISNULL(OLVASCSM.VarosID2, 0))) AND
						(CASE WHEN OLVASCSM.utcaid IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgUtcaID, 0) END = ISNULL(OLVASCSM.utcaid, 0))
			INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = OLVASCSM.LeolvasoID
			INNER JOIN USERS ON USERS.UserID = LEOLVASO.Userid
			LEFT JOIN leolvast ON leolvast.leolvastID = OLVASCSM.Munkavegzo
		WHERE FOHELY.FohelyID = @fohelyID AND FOHELY.Ig IS NULL AND FOHELY.Mero <> 1 AND LEOLVASO.PsionTip = 'A' AND OLVASCSM.Psionba IS NOT NULL AND OLVASCSM.Psionbol IS NULL AND OLVASCSM.Kartonra IS NULL
		GROUP BY ISNULL(leolvast.UserIDt, LEOLVASO.UserID)

		UNION

		SELECT USERS.UserID, NULL AS 'CsomagID', MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
		FROM NAPTAR
			 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
			 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
			 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
			 LEFT JOIN OCSEREES ON OCSEREES.OcsereerID = OCSEREER.OcsereerID
			 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
			 LEFT JOIN SZGHELY ON SZGHELY.SzghelyID = FOGYHELL.SzghelyID
			 LEFT JOIN FOHELY ON FOHELY.SzghelyID = SZGHELY.SzghelyID
		WHERE (OCSEREES.FohelyID = @fohelyID OR FOHELY.FohelyID = @fohelyID) AND USERS.SyncInterv IS NOT NULL
		GROUP BY USERS.UserID) L
		GROUP BY L.UserID

		OPEN OlvacsmCursor

		SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

		FETCH NEXT FROM OlvacsmCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @olvasID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

			FETCH NEXT FROM OlvacsmCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		END

		CLOSE OlvacsmCursor
		DEALLOCATE OlvacsmCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END