CREATE TRIGGER [dbo].[tr_olvast_update] ON [dbo].[OLVAST]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @olvastID int, @kelt date, @ora int, @m3 int, @creUser smallint, @creTime smalldatetime,
	@dOlvastID int, @dKelt date, @dOra int, @dM3 int, @dCreUser tinyint, @dCreTime smalldatetime,

	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @olvastID = OlvastID, @kelt = Kelt, @ora = Ora, @m3 = M3, @creUser = CreUser, @creTime = CreTime FROM inserted
	SELECT @dOlvastID = OlvastID, @dKelt = Kelt, @dOra = Ora, @dM3 = M3, @dCreUser = CreUser, @dCreTime = CreTime FROM deleted

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@kelt, '1900.01.01') = ISNULL(@dKelt, '1900.01.01') AND ISNULL(@ora, 0) = ISNULL(@dOra, 0) AND ISNULL(@m3, 0) = ISNULL(@dM3, 0) AND ISNULL(@creUser, 0) = ISNULL(@dCreUser, 0) AND ISNULL(@creTime, '1900.01.01') = ISNULL(@dCreTime, '1900.01.01')
		RETURN

	IF CURSOR_STATUS('global','OlvastCursor')>=-1
	BEGIN
		CLOSE OlvastCursor
		DEALLOCATE OlvastCursor
	END

	DECLARE OlvastCursor CURSOR FOR

	SELECT DISTINCT LEOLVASO.Userid
	FROM VIZMUVEK
		 INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = VIZMUVEK.Leolvaso
	WHERE LEOLVASO.Userid IS NOT NULL

	OPEN OlvastCursor

	IF @olvastID IS NOT NULL
	BEGIN
		IF @dOlvastID IS NULL
			SET @gcmMuvInt = 29 --j vztermels ralls
		ELSE
			SET @gcmMuvInt = 30 --Vztermels ralls mdosts
	END
	ELSE
	BEGIN
		SET @gcmMuvInt = 31 --Vztermels ralls trls
		SET @olvastID = @dOlvastID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @olvastID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (29,30))
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM OlvastCursor INTO @userID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, @olvastID, @userID)

			FETCH NEXT FROM OlvastCursor INTO @userID
		END

		CLOSE OlvastCursor
		DEALLOCATE OlvastCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END