CREATE TRIGGER [dbo].[tr_raktar_modify] ON [dbo].[RAKTAR] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @raktarID tinyint, @raktarNev varchar(30), @raktarCim varchar(50), @webShop bit, @megszunt bit,

		@dRaktarID tinyint, @dRaktarNev varchar(30), @dRaktarCim varchar(50), @dWebShop bit, @dMegszunt bit,

		@gcmMuvInt int

SELECT @raktarID=RaktarID, @raktarNev=RaktarNev, @raktarCim=RaktarCim, @webShop=ISNULL(WebShop,0), @megszunt=ISNULL(Megszunt,0) FROM inserted

SELECT @dRaktarID=RaktarID, @dRaktarNev=RaktarNev, @dRaktarCim=RaktarCim, @dWebShop=ISNULL(WebShop,0), @dMegszunt=ISNULL(Megszunt,0) FROM deleted

--olyan UPDATE, ahol nem rint rekordot, pl. javit.sql
IF @raktarID IS NULL AND @dRaktarID IS NULL
	RETURN

--Trls vagy (mdosts s (megszntt teszi vagy nem webShop))
IF (@raktarID IS NULL AND @dRaktarID IS NOT NULL) OR (@raktarID IS NOT NULL AND @dRaktarID IS NOT NULL AND ((@dMegszunt = 0 AND @megszunt = 1) OR (@dWebShop = 1 AND @webShop = 0)))
BEGIN
	--Megsznt vagy nem WebShop raktr trlst nem kell kikldeni
	IF @dMegszunt = 1 OR @dWebShop = 0
		RETURN

	SET @gcmMuvInt = 61 --Raktr trls
	SET @raktarID = @dRaktarID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @raktarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 60) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @raktarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 60) AND UserID = @webUserID2
END
--j vagy mdosts
ELSE
BEGIN
	SET @gcmMuvInt = 60 --Raktr letlts

	--Mdosts
	IF @dRaktarID IS NOT NULL
	BEGIN

		--Megsznt vagy nem WebShop raktr mdostst nem kell kikldeni
		IF @megszunt = 1 OR @webShop = 0
			RETURN

		--Ha nem vltozott az tadott rtkek valamelyike
		IF @raktarNev = @dRaktarNev AND ISNULL(@raktarCim,'') = ISNULL(@dRaktarCim,'') AND @webShop = @dWebShop AND	@megszunt = @dMegszunt
			RETURN

	END
	--j
	ELSE
	BEGIN
		--Megsznt vagy WebShop raktr rgztst nem kell kikldeni
		IF @megszunt = 1 OR @webShop = 0
			RETURN
	END
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@raktarID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@raktarID,@webUserID2)