CREATE TRIGGER [dbo].[tr_rendvfej_update] ON [dbo].[RENDVFEJ] 
FOR UPDATE
AS

DECLARE @rendvfejID int,  @wEBShop bit, @creUser smallint, @cikkID int, @raktarID tinyint, @rendelt numeric(10,2), @keszletID int, @valtozott bit = 0,

		@statusz char(1), @gyujtoje tinyint, @vevoID int, @kelt date, @fizmodID tinyint, @kiszallit bit, @vevokpcsID int, @telepID tinyint, @megjegyzes varchar(200), 
		@eredeti varchar(40), @kpVevonev varchar(8000), @csomSzall char(1), @csomPont varchar(20), @tetelszam smallint, @netto money, @brutto money,

		@dStatusz char(1), @dGyujtoje tinyint, @dVevoID int, @dKelt date, @dFizmodID tinyint, @dKiszallit bit, @dVevokpcsID int, @dTelepID tinyint, @dMegjegyzes varchar(200), 
		@dEredeti varchar(40), @dKpVevonev varchar(8000), @dCsomSzall char(1), @dCsomPont varchar(20), @dTetelszam smallint, @dNetto money, @dBrutto money

SELECT @rendvfejID=RendvfejID, @wEBShop=WEBShop, @creUser=CreUser,
	   @statusz=Statusz, @gyujtoje=Gyujtoje, @vevoID=VevoID, @kelt=Kelt, @fizmodID=Fizmodid, @kiszallit=Kiszallit, @vevokpcsID=VevokpcsID, @telepID=TelepID, @megjegyzes=Megjegyzes, 
	   @eredeti=Eredeti, @kpVevonev=KpVevonev, @csomSzall=CsomSzall, @csomPont=CsomPont, @tetelszam=Tetelszam, @netto=Netto, @brutto=Brutto
FROM inserted

SELECT @dStatusz=Statusz, @dGyujtoje=Gyujtoje, @dVevoID=VevoID, @dKelt=Kelt, @dFizmodID=Fizmodid, @dKiszallit=Kiszallit, @dVevokpcsID=VevokpcsID, @dTelepID=TelepID, @dMegjegyzes=Megjegyzes, 
	   @dEredeti=Eredeti, @dKpVevonev=KpVevonev, @dCsomSzall=CsomSzall, @dCsomPont=CsomPont, @dTetelszam=Tetelszam, @dNetto=Netto, @dBrutto=Brutto
FROM deleted

--Trlt sttusz
IF (@statusz = 'T' AND @dStatusz <> 'T') OR (@dStatusz = 'T' AND @statusz <> 'T')
BEGIN

	IF CURSOR_STATUS('global','RendvsorCursor')>=-1
	BEGIN
		CLOSE RendvsorCursor
		DEALLOCATE RendvsorCursor
	END

	DECLARE RendvsorCursor CURSOR FOR

	SELECT CikkID, Raktid
	FROM RENDVSOR
	WHERE RendvfejID = @rendvfejID AND CikkID > 0 AND Raktid > 0

	OPEN RendvsorCursor

	FETCH NEXT FROM RendvsorCursor INTO @cikkID, @raktarID
	WHILE @@FETCH_STATUS = 0
	BEGIN

		SELECT @rendelt=ISNULL(SUM(RENDVSOR.Mennyi),0)
		FROM RENDVSOR
				INNER JOIN RENDVFEJ ON RENDVFEJ.RendvfejID = RENDVSOR.RendvfejID
		WHERE RENDVFEJ.Statusz <> 'T' AND RENDVFEJ.Statusz <> 'S' AND RENDVSOR.CikkID = @cikkID AND RENDVSOR.Raktid = @raktarID AND RENDVSOR.SztetelID IS NULL AND RENDVSOR.BizSorID IS NULL

		SELECT @keszletID=KeszletID FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

		IF @keszletID IS NULL
			INSERT INTO KESZLET (CikkID,RaktarID,Foglalt) VALUES (@cikkID,@raktarID,@rendelt)
		ELSE
			UPDATE KESZLET SET Foglalt=@rendelt WHERE CikkID=@cikkID AND RaktarID=@raktarID

		FETCH NEXT FROM RendvsorCursor INTO @cikkID, @raktarID
	END

	CLOSE RendvsorCursor
	DEALLOCATE RendvsorCursor

END

--Ha webshop
IF @wEBShop = 1
BEGIN
	--Valamelyik tadott rtk vltozott
	IF @vevoID <> @dVevoID OR @kelt <> @dKelt OR @fizmodID <> @dFizmodID OR ISNULL(@kiszallit,0) <> ISNULL(@dKiszallit,0) OR ISNULL(@vevokpcsID,0) <> ISNULL(@dVevokpcsID,0) OR 
	   ISNULL(@telepID,0) <> ISNULL(@dTelepID,0) OR ISNULL(@megjegyzes,'') <> ISNULL(@dMegjegyzes,'') OR ISNULL(@eredeti,'') <> ISNULL(@dEredeti,'') OR 
	   ISNULL(@kpVevonev,'') <> ISNULL(@dKpVevonev,'') OR ISNULL(@csomSzall,'') <> ISNULL(@dCsomSzall,'') OR ISNULL(@csomPont,'') <> ISNULL(@dCsomPont,'') OR 
	   @tetelszam <> @dTetelszam OR @netto <> @dNetto OR @brutto <> @dBrutto
	BEGIN
		SET @valtozott=1
	END

	--vltozott a sttusz
	IF @valtozott = 1 OR @statusz <> @dStatusz
	BEGIN
		DECLARE @webUserID smallint, @webUserID2 smallint

		--WEB user azonost
		SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

		--WEB user azonost 2
		SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

		IF (@webUserID <> '' OR @webUserID2 <> '') AND (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		BEGIN
			IF @valtozott = 0
			BEGIN
				--Felvitel,Nyomtatva,Maradkos,Proforma szmla,Rszben sszeszedett --> Igny
				IF @statusz IN('F','N','M','P','R')
					SET @statusz = 'I'
				ELSE IF @statusz IN('S','K')
				--Szmlzva,Kiszlltva szlltlevlen --> Teljestve
					SET @statusz = 'T'
				--Trlt --> Nem teljeslt
				ELSE IF @statusz = 'T'
					SET @statusz = 'N'

				--Felvitel,Nyomtatva,Maradkos,Proforma szmla,Rszben sszeszedett --> Igny
				IF @dStatusz IN('F','N','M','P','R')
					SET @dStatusz = 'I'
				--Szmlzva,Kiszlltva szlltlevlen --> Teljestve
				ELSE IF @dStatusz IN('S','K')
					SET @dStatusz = 'T'
				--Trlt --> Nem teljeslt
				ELSE IF @dStatusz = 'T'
					SET @dStatusz = 'N'
			END

			IF @valtozott = 1 OR @statusz <> @dStatusz
			BEGIN
				IF @webUserID <> '' AND @creUser = @webUserID
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = CASE WHEN @valtozott = 1 THEN 107 ELSE 100 END),@rendvfejID,@webUserID)
			
				IF @webUserID2 <> '' AND @creUser = @webUserID2
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = CASE WHEN @valtozott = 1 THEN 107 ELSE 100 END),@rendvfejID,@webUserID2)
			END
		END
	END
END

--ha nem vltozott a gyjt
IF ISNULL(@gyujtoje, 0) = ISNULL(@dGyujtoje, 0)
	RETURN

DECLARE @token varchar(4096), @command varchar(8000), @proxyAcc varchar(50), @object int, @returnValue int, @tokens varchar(8000) = '', @toolsPath varchar(200)

SELECT TOP 1 @proxyAcc = LTRIM(RTRIM(ProxyAcc)), @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG ORDER BY CegID

IF(@proxyAcc IS NULL OR @proxyAcc = '')
BEGIN
	SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
	RETURN
END

IF @toolsPath IS NULL
		RETURN

IF RIGHT(@toolsPath,1) <> '\'
	SET @toolsPath = @toolsPath + '\'

DECLARE GcmUserCursor CURSOR FOR

SELECT DISTINCT GCMUSER.TOKEN
FROM GCMUSER
		INNER JOIN USERS ON USERS.UserID = GCMUSER.UserID
WHERE GCMUSER.ActivityNv = 'CikkOsszeszedesListActivity' AND GCMUSER.StepOuTime IS NULL

OPEN GcmUserCursor

FETCH NEXT FROM GcmUserCursor INTO @token
WHILE @@FETCH_STATUS = 0
BEGIN
	SET @tokens = @tokens + ',' + @token
	FETCH NEXT FROM GcmUserCursor INTO @token
END

CLOSE GcmUserCursor
DEALLOCATE GcmUserCursor

IF @tokens = ''
	RETURN

EXECUTE AS USER = @proxyAcc

SELECT @command = @toolsPath+'GCMSender\GCMSender.exe -apiKey:"AIzaSyC9PI42YCSuG0ERcQl9aDfJKdjq4xUp_FQ" -to:"'+@tokens+'" -data:"{ \"Muvelet\" : \"OsszeszedesFrissit\" }"'
EXEC sp_oacreate 'WScript.Shell', @object OUT
EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
EXEC sp_oadestroy @object

REVERT