CREATE TRIGGER [dbo].[tr_rendvsor_delete] ON [dbo].[RENDVSOR] 
FOR DELETE
AS

DECLARE @cikkID int, @raktarID tinyint, @rendvfejID int, @netto money, @tetelszam smallint, @afa money, @kedvezF numeric (5,2), @szlaRound tinyint, @rendelt numeric(10,2), @keszletID int

SELECT @rendvfejID=rendvfejID, @cikkID=CikkID, @raktarID=Raktid FROM deleted

SELECT @kedvezf=RENDVFEJ.Kedvezmeny, @szlaRound=DEVIZA.SzlaRound
FROM RENDVFEJ
     INNER JOIN DEVIZA ON RENDVFEJ.devizaid = DEVIZA.DevizaID
WHERE RENDVFEJ.RendvfejID=@rendvfejID

SELECT @netto=SUM(ISNULL(RENDVSOR.Egysegar,0) * RENDVSOR.Mennyi), 
       @afa=SUM(ISNULL(RENDVSOR.Egysegar,0) * RENDVSOR.Mennyi * (AFAK.Szaz/100)),
       @tetelszam=COUNT(RENDVSOR.RendvfejID)
FROM RENDVSOR
     LEFT JOIN AFAK ON RENDVSOR.Afaid=AFAK.AfaID WHERE RENDVSOR.RendvfejID=@rendvfejID

SET @kedvezF=ISNULL(@kedvezF,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @tetelszam=ISNULL(@tetelszam,0)

SET @netto=ROUND(@netto * (100-@kedvezF)/100, @szlaRound)
SET @afa=ROUND(@afa * (100-@kedvezF)/100, @szlaRound)

UPDATE RENDVFEJ SET Netto=@netto, Tetelszam=@tetelszam, Brutto=@netto + @afa WHERE RendvfejID=@rendvfejID

--kszlet
IF @cikkID IS NOT NULL AND @raktarID IS NOT NULL
BEGIN
    SELECT @rendelt=ISNULL(SUM(RENDVSOR.Mennyi),0)
    FROM RENDVSOR
         INNER JOIN RENDVFEJ ON RENDVFEJ.RendvfejID = RENDVSOR.RendvfejID
    WHERE RENDVFEJ.Statusz <> 'T' AND RENDVFEJ.Statusz <> 'S' AND RENDVFEJ.Statusz <> 'K' AND RENDVSOR.CikkID = @cikkID AND RENDVSOR.Raktid = @raktarID AND RENDVSOR.SztetelID IS NULL AND RENDVSOR.BizSorID IS NULL AND RENDVSOR.PsztetelID IS NULL

    SELECT @keszletID=KeszletID FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

    IF @keszletID IS NULL
        INSERT INTO KESZLET (CikkID,RaktarID,Foglalt) VALUES (@cikkID,@raktarID,@rendelt)
    ELSE
        UPDATE KESZLET SET Foglalt=@rendelt WHERE CikkID=@cikkID AND RaktarID=@raktarID
END