CREATE TRIGGER [dbo].[tr_szghely_modify_kuka] ON [dbo].[SZGHELY]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @szghelyID int, @szgVarosID smallint, @szgUtcaID smallint, @szgCimveg varchar(15), @szgcimKieg varchar(50), @urUtcaID smallint, @urCimveg varchar(15),
			@dSzghelyID int, @dSzgVarosID smallint, @dSzgUtcaID smallint, @dSzgCimveg varchar(15), @dSzgcimKieg varchar(50), @dUrUtcaID smallint, @dUrCimveg varchar(15),
			@webUserID smallint

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN

	IF CURSOR_STATUS('global','SzghelyCursor')>=-1
	BEGIN
		CLOSE SzghelyCursor
		DEALLOCATE SzghelyCursor
	END

	DECLARE SzghelyCursor CURSOR FOR

	SELECT inserted.SzghelyID, deleted.SzghelyID, inserted.SzgVarosID, deleted.SzgVarosID, inserted.SzgUtcaID, deleted.SzgUtcaID, inserted.SzgCimveg, deleted.SzgCimveg, inserted.SzgcimKieg, deleted.SzgcimKieg, inserted.UrUtcaID, deleted.UrUtcaID, inserted.UrCimveg, deleted.UrCimveg
	FROM deleted
		 LEFT JOIN inserted ON inserted.SzghelyID = deleted.SzghelyID
	     INNER JOIN KEDENY ON KEDENY.SzghelyiD = deleted.SzghelyID
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.SzghelyID, deleted.SzghelyID, inserted.SzgVarosID, deleted.SzgVarosID, inserted.SzgUtcaID, deleted.SzgUtcaID, inserted.SzgCimveg, deleted.SzgCimveg, inserted.SzgcimKieg, deleted.SzgcimKieg, inserted.UrUtcaID, deleted.UrUtcaID, inserted.UrCimveg, deleted.UrCimveg

	OPEN SzghelyCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM SzghelyCursor INTO @szghelyID, @dSzghelyID, @szgVarosID, @dSzgVarosID, @szgUtcaID, @dSzgUtcaID, @szgCimveg, @dSzgCimveg, @szgcimKieg, @dSzgcimKieg, @urUtcaID, @dUrUtcaID, @urCimveg, @dUrCimveg
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@szgVarosID, 0) <> ISNULL(@dSzgVarosID, 0) OR ISNULL(@szgcimKieg, '') <> ISNULL(@dSzgcimKieg, '') OR ISNULL(@urUtcaID, 0) <> ISNULL(@dUrUtcaID, 0) OR ISNULL(@urCimveg, 0) <> ISNULL(@dUrCimveg, 0) OR 
			   --ha nincs megadva rtsi utca s vltozott a szolgltatsi hely cme
			   (@urUtcaID IS NULL AND @dUrUtcaID IS NULL AND (ISNULL(@szgUtcaID, 0) <> ISNULL(@dSzgUtcaID, 0) OR ISNULL(@szgCimveg, '') <> ISNULL(@dSzgCimveg, '')))
			BEGIN
				
				--Vros vltozs
				IF ISNULL(@szgVarosID, 0) <> ISNULL(@dSzgVarosID, 0)
				BEGIN
					--Rgi vros nem aktv sehol
					IF (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE SZGHELY.SzgVarosID = @dSzgVarosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND SZGHELY.SzghelyID <> ISNULL(@szghelyID,@dSzghelyID) AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))) = 0
					BEGIN
						UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dSzgVarosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70) --Zrtt tenni a korbbi letlts esemnyt
						INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 71), @dSzgVarosID, @webUserID) --Vros trls
					END

					--j vros nem aktv sehol
					IF (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE SZGHELY.SzgVarosID = @szgVarosID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND SZGHELY.SzghelyID <> ISNULL(@szghelyID,@dSzghelyID) AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))) = 0
					BEGIN
						UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szgVarosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 71) --Zrtt tenni a korbbi trls esemnyt
						INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70), @szgVarosID, @webUserID) --Vros letlts
					END
				END

				--Utca vltozs
				IF ISNULL(@szgUtcaID, 0) <> ISNULL(@dSzgUtcaID, 0)
				BEGIN
					--Rgi utca nem aktv sehol
					IF (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @dSzgUtcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND SZGHELY.SzghelyID <> ISNULL(@szghelyID,@dSzghelyID) AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))) = 0
					BEGIN
						UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @dSzgUtcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72) --Zrtt tenni a korbbi letlts esemnyt
						INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 73), @dSzgUtcaID, @webUserID) --Utca trls
					END

					--j utca nem aktv sehol
					IF (SELECT COUNT(*)
					FROM KEDENY
						 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
						 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
					WHERE ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = @szgUtcaID AND KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND SZGHELY.SzghelyID <> ISNULL(@szghelyID,@dSzghelyID) AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))) = 0
					BEGIN
						UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szgUtcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 73) --Zrtt tenni a korbbi trls esemnyt
						INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72), @szgUtcaID, @webUserID) --Utca letlts
					END
				END

				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = ISNULL(@szghelyID,@dSzghelyID) AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @szghelyID IS NULL THEN 16 ELSE 89 END)) --Zrtt tenni a korbbi esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @szghelyID IS NULL THEN 89 ELSE 16 END)), ISNULL(@szghelyID,@dSzghelyID), @webUserID)
			END

			FETCH NEXT FROM SzghelyCursor INTO @szghelyID, @dSzghelyID, @szgVarosID, @dSzgVarosID, @szgUtcaID, @dSzgUtcaID, @szgCimveg, @dSzgCimveg, @szgcimKieg, @dSzgcimKieg, @urUtcaID, @dUrUtcaID, @urCimveg, @dUrCimveg
		END

		CLOSE SzghelyCursor
		DEALLOCATE SzghelyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END