CREATE TRIGGER [dbo].[tr_szghely_update] ON [dbo].[SZGHELY]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @szghelyID int, 
	@lakatlan bit, @vevoID int, @szgCim varchar(40),
	@dLakatlan varchar(15), @dVevoID int, @dSzgCim varchar(40),
	@vevoKpcsID int, --tulajdonos csere miatti vevkapcsolat azonost
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @csomagID int, @fogyHEllID int, @ocsereerID int,
	@vevoGcmMuvID int, @vevoKpcsGcmMuvID int

	SELECT @szghelyID = SzghelyID, @vevoID = VevoID, @szgCim = SzgCim FROM inserted
	SELECT @szghelyID = SzghelyID, @dVevoID = VevoID, @dSzgCim = SzgCim FROM deleted

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@lakatlan, 0) = ISNULL(@dLakatlan, 0) AND ISNULL(@vevoID, 0) = ISNULL(@dVevoID, 0) AND ISNULL(@szgCim, '') = ISNULL(@dSzgCim, '')
		RETURN

	IF CURSOR_STATUS('global','SzghelyCursor')>=-1
	BEGIN
		CLOSE SzghelyCursor
		DEALLOCATE SzghelyCursor
	END

	DECLARE SzghelyCursor CURSOR FOR

	SELECT L.UserID, MAX(L.CsomagID) AS 'CsomagID', MAX(L.FogyHEllID) AS 'FogyHEllID', MAX(L.OcsereerID) AS 'OcsereerID' FROM (
	SELECT ISNULL(leolvast.UserIDt, LEOLVASO.UserID) AS 'UserID', MAX(OLVASCSM.CsomagID) AS 'CsomagID', NULL AS 'FogyHEllID', NULL AS 'OcsereerID'
	FROM FOHELY
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = FOHELY.SzghelyID
		 JOIN OLVASCSM ON
					(CASE WHEN OLVASCSM.LeolvasoID IS NULL AND OLVASCSM.Leolvas2ID IS NULL THEN 0 ELSE ISNULL(SZGHELY.Leolvaso, 0) END IN (ISNULL(OLVASCSM.LeolvasoID, 0), ISNULL(OLVASCSM.Leolvas2ID, 0))) AND
					(CASE WHEN OLVASCSM.SzgcsopID IS NULL AND OLVASCSM.SzgCsopID2 IS NULL THEN 0 ELSE SZGHELY.SzgCsopID END IN (ISNULL(OLVASCSM.SzgcsopID, 0), ISNULL(OLVASCSM.SzgCsopID2, 0))) AND
					(CASE WHEN OLVASCSM.SzlaciklID IS NULL AND OLVASCSM.Szlacikli2 IS NULL THEN 0 ELSE SZGHELY.SzlaCiklID END IN (ISNULL(OLVASCSM.SzlaciklID, 0), ISNULL(OLVASCSM.Szlacikli2, 0))) AND
					(CASE WHEN OLVASCSM.Varosid IS NULL AND OLVASCSM.VarosID2 IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgVarosID, 0) END IN (ISNULL(OLVASCSM.Varosid, 0), ISNULL(OLVASCSM.VarosID2, 0))) AND
					(CASE WHEN OLVASCSM.utcaid IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgUtcaID, 0) END = ISNULL(OLVASCSM.utcaid, 0))
		INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = OLVASCSM.LeolvasoID
		INNER JOIN USERS ON USERS.UserID = LEOLVASO.Userid
		LEFT JOIN leolvast ON leolvast.leolvastID = OLVASCSM.Munkavegzo
	WHERE SZGHELY.SzghelyID = @szghelyID AND FOHELY.Ig IS NULL AND FOHELY.Mero <> 1 AND LEOLVASO.PsionTip = 'A' AND OLVASCSM.Psionba IS NOT NULL AND OLVASCSM.Psionbol IS NULL AND OLVASCSM.Kartonra IS NULL
	GROUP BY ISNULL(leolvast.UserIDt, LEOLVASO.UserID)

	UNION

	SELECT USERS.UserID, NULL AS 'CsomagID', MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
	FROM NAPTAR
		 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
		 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
		 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
		 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
	WHERE (OCSEREER.SzghelyID = @szghelyID OR FOGYHELL.SzghelyID = @szghelyID) AND USERS.SyncInterv IS NOT NULL
	GROUP BY USERS.UserID) L
	GROUP BY L.UserID

	OPEN SzghelyCursor

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 16 --Szolgltatsi hely mdosts

	--Tulajdonos csere
	IF ISNULL(@vevoID, 0) <> ISNULL(@dVevoID, 0)
	BEGIN
		SELECT @vevoGcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17 --Vev mdosts
		SELECT @vevoKpcsGcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 12 --Vev elrhetsg mdosts

		IF CURSOR_STATUS('global','VevoKpcsCursor')>=-1
		BEGIN
			CLOSE VevoKpcsCursor
			DEALLOCATE VevoKpcsCursor
		END

		DECLARE VevoKpcsCursor CURSOR FOR

		--Telefon s mobiltelefon
		SELECT VevokpcsID
		FROM VEVOKPCS
		WHERE KapcsTip IN(1,2) AND VevoID = @vevoID

		OPEN VevoKpcsCursor
	END

	BEGIN TRY

		BEGIN TRAN

		FETCH NEXT FROM SzghelyCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @szghelyID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

			--Tulajdonos csere
			IF @vevoGcmMuvID IS NOT NULL
			BEGIN
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@vevoGcmMuvID, @vevoID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

				FETCH NEXT FROM VevoKpcsCursor INTO @vevoKpcsID
				WHILE @@FETCH_STATUS = 0
				BEGIN
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@vevoKpcsGcmMuvID, @vevoKpcsID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

					FETCH NEXT FROM VevoKpcsCursor INTO @vevoKpcsID
				END
			END

			FETCH NEXT FROM SzghelyCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		END

		CLOSE SzghelyCursor
		DEALLOCATE SzghelyCursor

		--Tulajdonos csere
		IF @vevoGcmMuvID IS NOT NULL
		BEGIN
			CLOSE VevoKpcsCursor
			DEALLOCATE VevoKpcsCursor
		END

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END