CREATE TRIGGER [dbo].[tr_terhely_update] ON [dbo].[TERHELY]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @terhelyID int, @terhelyNev varchar(40), @gyszam varchar(20), @meret tinyint, @tipus tinyint, @hitelesEv smallint, @latti numeric(10,6), @longi numeric(10,6),
	@dTerhelyID int, @dTerhelyNev varchar(40), @dGyszam varchar(20), @dMeret tinyint, @dTipus tinyint, @dHitelesEv smallint, @dLatti numeric(10,6), @dLongi numeric(10,6),
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @terhelyID = TerhelyID, @terhelyNev = TerhelyNev, @gyszam = Gyszam, @meret = Meret, @tipus = Tipus, @hitelesEv = HitelesEv, @latti = Latti, @longi = Longi FROM inserted
	SELECT @dTerhelyID = TerhelyID, @dTerhelyNev = TerhelyNev, @dGyszam = Gyszam, @dMeret = Meret, @dTipus = Tipus, @dHitelesEv = HitelesEv, @dLatti = Latti, @dLongi = Longi FROM deleted

	--ha nem vltozott a leolvasshoz tadott rtkek valamelyike
	IF ISNULL(@terhelyNev, '') = ISNULL(@dTerhelyNev, '') AND ISNULL(@gyszam, '') = ISNULL(@dGyszam, '') AND ISNULL(@meret, 0) = ISNULL(@dMeret, 0) AND ISNULL(@tipus, 0) = ISNULL(@dTipus, 0) AND ISNULL(@hitelesEv, 0) = ISNULL(@dHitelesEv, 0) AND ISNULL(@latti, 0) = ISNULL(@dLatti, 0) AND ISNULL(@longi, 0) = ISNULL(@dLongi, 0)
		RETURN

	IF CURSOR_STATUS('global','TerhelyCursor')>=-1
	BEGIN
		CLOSE TerhelyCursor
		DEALLOCATE TerhelyCursor
	END

	DECLARE TerhelyCursor CURSOR FOR

	SELECT DISTINCT LEOLVASO.Userid
	FROM VIZMUVEK
		 INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = VIZMUVEK.Leolvaso
	WHERE LEOLVASO.Userid IS NOT NULL

	OPEN TerhelyCursor

	IF @terhelyID IS NOT NULL
	BEGIN
		IF @dTerhelyID IS NULL
			SET @gcmMuvInt = 26 --j vztermels ra
		ELSE
			SET @gcmMuvInt = 27 --Vztermels ra mdosts
	END
	ELSE
	BEGIN
		SET @gcmMuvInt = 28 --Vztermels ra trls
		SET @terhelyID = @dTerhelyID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @terhelyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (26,27))
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM TerhelyCursor INTO @userID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, @terhelyID, @userID)

			FETCH NEXT FROM TerhelyCursor INTO @userID
		END

		CLOSE TerhelyCursor
		DEALLOCATE TerhelyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END