CREATE TRIGGER [dbo].[tr_varosok_modify_kuka] ON [dbo].[VAROSOK]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @varosID smallint, @varosIrsz varchar(10), @varosNev varchar(40),
			@dVarosID smallint, @dVarosIrsz varchar(10), @dVarosNev varchar(40),
			@webUserID smallint, @gcmMuvID int

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN
	
	IF CURSOR_STATUS('global','VarosCursor')>=-1
	BEGIN
		CLOSE VarosCursor
		DEALLOCATE VarosCursor
	END

	DECLARE VarosCursor CURSOR FOR

	SELECT inserted.VarosID, deleted.VarosID, inserted.VarosIrsz, deleted.VarosIrsz, inserted.VarosNev, deleted.VarosNev
	FROM deleted
		 LEFT JOIN inserted ON inserted.VarosID = deleted.VarosID
		 INNER JOIN SZGHELY ON SZGHELY.SzgVarosID = deleted.VarosID
	     INNER JOIN KEDENY ON KEDENY.SzghelyID = SZGHELY.SzghelyID
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.VarosID, deleted.VarosID, inserted.VarosIrsz, deleted.VarosIrsz, inserted.VarosNev, deleted.VarosNev

	OPEN VarosCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM VarosCursor INTO @varosID, @dVarosID, @varosIrsz, @dVarosIrsz, @varosNev, @dVarosNev
		WHILE @@FETCH_STATUS = 0
		BEGIN

			IF @gcmMuvID IS NULL
				SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @varosID IS NULL THEN 71 ELSE 70 END) --71: Vros trls, 70: Vros mdosts

			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@varosIrsz, '') <> ISNULL(@dVarosIrsz, '') OR ISNULL(@varosNev, '') <> ISNULL(@dVarosNev, '')
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, ISNULL(@varosID,@dVarosID), @webUserID)

			FETCH NEXT FROM VarosCursor INTO @varosID, @dVarosID, @varosIrsz, @dVarosIrsz, @varosNev, @dVarosNev
		END

		CLOSE VarosCursor
		DEALLOCATE VarosCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END