CREATE TRIGGER [dbo].[tr_vevo_modify] ON [dbo].[VEVO] FOR INSERT,UPDATE
AS

DECLARE @webUserID smallint, @creUser smallint, @vevoID int, @gVevoID int, @uzltkotID tinyint, @dVevoID int, @dGVevoID int, @vevoRegID int, @gcmMuvInt int, @eUgyfelServerEler bit = 0

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

IF @webUserID = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

--Ha a Kristly kezeli az E-gyfl interfsz adatbzist
IF (SELECT COUNT(*) FROM CEG WHERE ISNULL(EugyServer,'') <> '' AND ISNULL(EugyDB,'') <> '' AND ISNULL(EugyUser,'') <> '' AND ISNULL(EugyPass,'') <> '') > 0
	SET @eUgyfelServerEler = 1

SELECT @vevoID=VevoID, @gVevoID=Gvevoid, @creUser=CreUser, @uzltkotID=UzltkotID FROM inserted

SELECT @dVevoID=VevoID, @dGVevoID=Gvevoid FROM deleted

--Ha j rgzts s e-gyfl
IF @dVevoID IS NULL AND @gVevoID IS NOT NULL
BEGIN
	SELECT @vevoRegID=VevoregID FROM VEVOREG WHERE EUgyfelID = @gVevoID

	--Ha nem Webshop regisztrci
	IF @vevoRegID IS NULL
		RETURN

	UPDATE VEVOREG SET VevoID=@vevoID, Rendben=1, Statusz = 'A' WHERE VevoregID = @vevoRegID

	UPDATE ARAJVFEJ SET vevoid=@vevoID, UzlkotoID=@uzltkotID WHERE VevoregID = @vevoRegID

	IF @eUgyfelServerEler = 1
		RETURN

	--j rgzts (nem WEB user ltal)
	IF @dVevoID IS NULL AND @creUser <> @webUserID
	BEGIN
		--Webshop vev aktivls
		SET @gcmMuvInt = 66

		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vevoRegID,@webUserID)
	END
END
--Ha mdosts s aktivls vagy deaktivls
ELSE IF @dVevoID IS NOT NULL AND ((@dGVevoID IS NULL AND @gVevoID IS NOT NULL) OR (@gVevoID IS NULL AND @dGVevoID IS NOT NULL))
BEGIN

	IF @eUgyfelServerEler = 1
		RETURN

	SELECT @vevoRegID=VevoregID FROM VEVOREG WHERE EUgyfelID = ISNULL(@gVevoID,@dGVevoID)

	--Ha nem Webshop regisztrci
	IF @vevoRegID IS NULL
		RETURN

	IF @dGVevoID IS NULL AND @gVevoID IS NOT NULL
		SET @gcmMuvInt = 66 --Webshop vev aktivls
	ELSE
		SET @gcmMuvInt = 67 --Webshop vev deaktivls

	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vevoRegID,@webUserID)
END