CREATE TRIGGER [dbo].[tr_vevo_modify_webshop] ON [dbo].[VEVO]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @vevoregID int, @gVevoID int, @elo varchar(5), @vevoNev varchar(40), @vevoNevF varchar(50), @varosID smallint, @cim varchar(50), 
		    @adoszam varchar(14), @arkategKod char(3), @kedvezmeny numeric(3,1), @fizkod char(1), @fiznap tinyint, @uzltkotID tinyint,

			@dGVevoID int, @dElo varchar(5), @dVevoNev varchar(40), @dVevoNevF varchar(50), @dVarosID smallint, @dCim varchar(50),
			@dAdoszam varchar(14), @dArkategKod char(3), @dKedvezmeny numeric(3,1), @dFizkod char(1), @dFiznap tinyint, @dUzltkotID tinyint,
			@webUserID smallint, @webUserID2 smallint

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	--WEB user azonost 2
	SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

	IF @webUserID = '' AND @webUserID2 = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') = 0
		RETURN

	SELECT @vevoregID=VEVOREG.VevoregID, @gVevoID=inserted.Gvevoid, @elo=inserted.Elo, @vevoNev=inserted.VevoNev, @vevoNevF=inserted.VevoNevF, @varosID=inserted.VarosID, @cim=inserted.Cim, 
		   @adoszam=inserted.Adoszam, @arkategKod=ARKATEG.Arkategkod, @kedvezmeny=inserted.Kedvezmeny, @fizkod=FIZMODOK.Fizkod, @fiznap=inserted.Fiznap, @uzltkotID=inserted.UzltkotID
	FROM inserted
		 INNER JOIN ARKATEG ON ARKATEG.ArkategID = inserted.ArKategID
		 INNER JOIN FIZMODOK ON FIZMODOK.FizmodId = inserted.FizmodID
		 INNER JOIN VEVOREG ON VEVOREG.VevoID = inserted.VevoID

	SELECT @dGVevoID=Gvevoid, @dElo=deleted.Elo, @dVevoNev=deleted.VevoNev, @dVevoNevF=deleted.VevoNevF, @dVarosID=deleted.VarosID, @dCim=deleted.Cim, 
		   @dAdoszam=deleted.Adoszam, @dArkategKod=ARKATEG.Arkategkod, @dKedvezmeny=deleted.Kedvezmeny, @dFizkod=FIZMODOK.Fizkod, @dFiznap=deleted.Fiznap, @dUzltkotID=deleted.UzltkotID
	FROM deleted
		 INNER JOIN ARKATEG ON ARKATEG.ArkategID = deleted.ArKategID
		 INNER JOIN FIZMODOK ON FIZMODOK.FizmodId = deleted.FizmodID
		 INNER JOIN VEVOREG ON VEVOREG.VevoID = deleted.VevoID

	--Csak webshop vev mdosts
	IF @gVevoID IS NULL OR @dGVevoID IS NULL
		RETURN

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@elo, '') = ISNULL(@dElo, '') AND @vevoNev = @dVevoNev AND ISNULL(@vevoNevF, '') = ISNULL(@dVevoNevF, '') AND 
	   ISNULL(@varosID, 0) = ISNULL(@dVarosID, 0) AND ISNULL(@cim, '') = ISNULL(@dCim, '') AND LTRIM(RTRIM(REPLACE(ISNULL(@adoszam, ''),'-',''))) = LTRIM(RTRIM(REPLACE(ISNULL(@dAdoszam, ''),'-',''))) AND 
	   @arkategKod = @dArkategKod AND ISNULL(@kedvezmeny, 0) = ISNULL(@dKedvezmeny, 0) AND @fizkod = @dFizkod AND
	   ISNULL(@fiznap, 0) = ISNULL(@dFiznap, 0) AND ISNULL(@uzltkotID, 0) = ISNULL(@uzltkotID, 0)
		RETURN

	IF @webUserID <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17),@vevoregID,@webUserID)

	IF @webUserID2 <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17),@vevoregID,@webUserID2)

END TRY
BEGIN CATCH
END CATCH
END