CREATE TRIGGER [dbo].[tr_vevo_update] ON [dbo].[VEVO]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @vevoID int, 
	@vevoNev varchar(40), @varosID int, @cim varchar(50), @fizeto int,
	@dVevoNev varchar(40), @dVarosID int, @dCim varchar(50), @dFizeto int,@gvevoid int,@eugyfel bit,@dgvevoid int,@deugyfel bit,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @csomagID int, @fogyHEllID int, @ocsereerID int

	SELECT @vevoID = VevoID, @vevoNev = VevoNev, @varosID = VarosID, @cim = Cim, @fizeto = Fizeto,@gvevoid=isnull(Gvevoid,0),@eugyfel=isnull(eugyfel,0) FROM inserted
	SELECT @vevoID = VevoID, @dVevoNev = VevoNev, @dVarosID = VarosID, @dCim = Cim, @dFizeto = Fizeto,@dgvevoid=isnull(Gvevoid,0),@deugyfel=isnull(eugyfel,0) FROM deleted

	if @eugyfel=1 and @gvevoid>0 and @dgvevoid=0	   
	     update REKLAMAL set Ugyzart='I' where Vevoid=@vevoID and Ugyzart='N' and ReklSzoveg like('%vev e-gyfl regisztrci igny (web)%')
	   
	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@vevoNev, '') = ISNULL(@dVevoNev, '') AND ISNULL(@varosID, '') = ISNULL(@dVarosID, '') AND ISNULL(@cim, '') = ISNULL(@dCim, '') AND ISNULL(@fizeto, '') = ISNULL(@dFizeto, '')
		RETURN

	IF CURSOR_STATUS('global','VevoCursor')>=-1
	BEGIN
		CLOSE VevoCursor
		DEALLOCATE VevoCursor
	END

	DECLARE VevoCursor CURSOR FOR

	SELECT L.UserID, MAX(L.CsomagID) AS 'CsomagID', MAX(L.FogyHEllID) AS 'FogyHEllID', MAX(L.OcsereerID) AS 'OcsereerID' FROM (
	SELECT ISNULL(leolvast.UserIDt, LEOLVASO.UserID) AS 'UserID', MAX(OLVASCSM.CsomagID) AS 'CsomagID', NULL AS 'FogyHEllID', NULL AS 'OcsereerID'
	FROM FOHELY
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = FOHELY.SzghelyID
		 INNER JOIN VEVO ON VEVO.VevoID = SZGHELY.VevoID
		 JOIN OLVASCSM ON
					(CASE WHEN OLVASCSM.LeolvasoID IS NULL AND OLVASCSM.Leolvas2ID IS NULL THEN 0 ELSE ISNULL(SZGHELY.Leolvaso, 0) END IN (ISNULL(OLVASCSM.LeolvasoID, 0), ISNULL(OLVASCSM.Leolvas2ID, 0))) AND
					(CASE WHEN OLVASCSM.SzgcsopID IS NULL AND OLVASCSM.SzgCsopID2 IS NULL THEN 0 ELSE SZGHELY.SzgCsopID END IN (ISNULL(OLVASCSM.SzgcsopID, 0), ISNULL(OLVASCSM.SzgCsopID2, 0))) AND
					(CASE WHEN OLVASCSM.SzlaciklID IS NULL AND OLVASCSM.Szlacikli2 IS NULL THEN 0 ELSE SZGHELY.SzlaCiklID END IN (ISNULL(OLVASCSM.SzlaciklID, 0), ISNULL(OLVASCSM.Szlacikli2, 0))) AND
					(CASE WHEN OLVASCSM.Varosid IS NULL AND OLVASCSM.VarosID2 IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgVarosID, 0) END IN (ISNULL(OLVASCSM.Varosid, 0), ISNULL(OLVASCSM.VarosID2, 0))) AND
					(CASE WHEN OLVASCSM.utcaid IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgUtcaID, 0) END = ISNULL(OLVASCSM.utcaid, 0))
		INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = OLVASCSM.LeolvasoID
		INNER JOIN USERS ON USERS.UserID = LEOLVASO.Userid
		LEFT JOIN leolvast ON leolvast.leolvastID = OLVASCSM.Munkavegzo
	WHERE (VEVO.VevoID = @vevoID OR VEVO.Fizeto = @vevoID) AND FOHELY.Ig IS NULL AND FOHELY.Mero <> 1 AND LEOLVASO.PsionTip = 'A' AND OLVASCSM.Psionba IS NOT NULL AND OLVASCSM.Psionbol IS NULL AND OLVASCSM.Kartonra IS NULL
	GROUP BY ISNULL(leolvast.UserIDt, LEOLVASO.UserID)

	UNION

	SELECT USERS.UserID, NULL AS 'CsomagID', MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
	FROM NAPTAR
		 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
		 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
		 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
		 LEFT JOIN SZGHELY SZGHELY_OCSEREER ON SZGHELY_OCSEREER.SzghelyID = OCSEREER.SzghelyID
		 LEFT JOIN VEVO VEVO_OCSEREER ON VEVO_OCSEREER.VevoID = SZGHELY_OCSEREER.VevoID
		 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
		 LEFT JOIN SZGHELY SZGHELY_FOGYHELL ON SZGHELY_FOGYHELL.SzghelyID = FOGYHELL.SzghelyID
		 LEFT JOIN VEVO VEVO_FOGYHELL ON VEVO_FOGYHELL.VevoID = SZGHELY_OCSEREER.VevoID
	WHERE (VEVO_OCSEREER.VevoID = @vevoID OR VEVO_OCSEREER.Fizeto = @vevoID OR VEVO_FOGYHELL.VevoID = @vevoID OR VEVO_FOGYHELL.Fizeto = @vevoID) AND USERS.SyncInterv IS NOT NULL
	GROUP BY USERS.UserID) L
	GROUP BY L.UserID

	OPEN VevoCursor

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 17 --Vev mdosts

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM VevoCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @vevoID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

			FETCH NEXT FROM VevoCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		END

		CLOSE VevoCursor
		DEALLOCATE VevoCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END