CREATE TRIGGER [dbo].[tr_villora_update] ON [dbo].[VILLORA]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @villoraID int, @kelt date, @ora int, @fogyaszt int, @villOlvmID smallint, @creUser smallint, @creTime smalldatetime, @oWattos int, @csWattos int, @cskWattos int, @oInduktiv int, @oKapacitiv int, @csMax int, @cskMax int,
	@dVilloraID int, @dKelt date, @dOra int, @dFogyaszt int, @dVillOlvmID smallint, @dCreUser tinyint, @dCreTime smalldatetime, @dOWattos int, @dCsWattos int, @dCskWattos int, @dOInduktiv int, @dOKapacitiv int, @dCsMax int, @dCskMax int,

	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @villoraID = VillOraID, @kelt = Kelt, @ora = Ora, @fogyaszt = Fogyaszt, @villOlvmID = VillOlvmID, @creUser = CreUser, @creTime = CreTime, @oWattos = OWattos, @csWattos = CsWattos, @cskWattos = CskWattos, @oInduktiv = OInduktiv, @oKapacitiv = Okapacitiv, @csMax = CsMax, @cskMax = CskMax FROM inserted
	SELECT @dVilloraID = VillOraID, @dKelt = Kelt, @dOra = Ora, @dFogyaszt = Fogyaszt, @dVillOlvmID = VillOlvmID, @dCreUser = CreUser, @dCreTime = CreTime, @doWattos = OWattos, @dcsWattos = CsWattos, @dcskWattos = CskWattos, @doInduktiv = OInduktiv, @doKapacitiv = Okapacitiv, @dcsMax = CsMax, @dcskMax = CskMax FROM deleted

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@kelt, '1900.01.01') = ISNULL(@dKelt, '1900.01.01') AND ISNULL(@ora, 0) = ISNULL(@dOra, 0) AND ISNULL(@fogyaszt, 0) = ISNULL(@dFogyaszt, 0) AND ISNULL(@villOlvmID, 0) = ISNULL(@dVillOlvmID, 0) AND ISNULL(@creUser, 0) = ISNULL(@dCreUser, 0) AND 
	   ISNULL(@creTime, '1900.01.01') = ISNULL(@dCreTime, '1900.01.01') AND ISNULL(@oWattos, 0) = ISNULL(@dOWattos, 0) AND ISNULL(@csWattos, 0) = ISNULL(@dCsWattos, 0) AND ISNULL(@cskWattos, 0) = ISNULL(@dCskWattos, 0) AND ISNULL(@oInduktiv, 0) = ISNULL(@dOInduktiv, 0) AND 
	   ISNULL(@oKapacitiv, 0) = ISNULL(@dOKapacitiv, 0) AND ISNULL(@csMax, 0) = ISNULL(@dCsMax, 0) AND ISNULL(@cskMax, 0) = ISNULL(@dCskMax, 0)
		RETURN

	IF CURSOR_STATUS('global','VilloraCursor')>=-1
	BEGIN
		CLOSE VilloraCursor
		DEALLOCATE VilloraCursor
	END

	DECLARE VilloraCursor CURSOR FOR

	SELECT DISTINCT LEOLVASO.Userid FROM LEOLVASO
		   LEFT JOIN VILLFOGY ON LEOLVASO.LeolvasoID = VILLFOGY.LeolvasoID
		   LEFT JOIN VIZMUVEK ON LEOLVASO.LeolvasoID = VIZMUVEK.Leolvaso
	WHERE LEOLVASO.Userid IS NOT NULL AND (VILLFOGY.VillfogyID IS NOT NULL OR VIZMUVEK.VizmuvekID IS NOT NULL)

	OPEN VilloraCursor

	IF @villoraID IS NOT NULL
	BEGIN
		IF @dVilloraID IS NULL
			SET @gcmMuvInt = 21 --j villamos ralls
		ELSE
			SET @gcmMuvInt = 22 --Villamos ralls mdosts
	END
	ELSE
	BEGIN
		SET @gcmMuvInt = 23 --Villamos ralls trls
		SET @villoraID = @dVilloraID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @villoraID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (21,22))
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM VilloraCursor INTO @userID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, @villoraID, @userID)

			FETCH NEXT FROM VilloraCursor INTO @userID
		END

		CLOSE VilloraCursor
		DEALLOCATE VilloraCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END